package gate.pattern;

import gate.util.CommonMethod;
import gate.util.GateException;

import java.io.File;  
import java.io.InputStreamReader;  
import java.io.BufferedReader;  
import java.io.BufferedWriter;  
import java.io.FileInputStream;  
import java.io.FileWriter;  


import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import clearnlp.DepRelParser;
import clearnlp.SentenceRelationModel;




public class CarreRule
{
	//public String[] name;
	public List<RuleModel> rules;
	public Map<String, List<String>> patlist; 
	private static CarreRule instance;

	
	public List<RuleModel> getRules(){
		return rules;
	}
	
	public Map<String, List<String>> getPatlist(){
		return patlist;
	}
	public static CarreRule getInstance() throws  IOException{
		if(instance==null){
			instance = new CarreRule();
		}
		return instance;
	}
	
	public static void main(String args[]){
		try {
			CarreRule.getInstance();
			CarreRule.getInstance();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public CarreRule (){
		
		initial();
	}
	public void  initial() 
	{  
		CommonMethod.screenPrint("in initial");
		   RuleModel Ruletemp = new RuleModel();
		   PatternRuleModel patternRuleTemp = new PatternRuleModel(); 	
		   patlist=new HashMap<String, List<String>>();
		   try 
	       { 
			
			int inttype=0;
	        int intclassnum=0;
	        int intpatternnum=0;
	        
	        String strtemp;	        
	    	//String pathname = "F:\\pattern.txt";   //@todo
	        String pathname = "D:\\GateConfig\\pattern.txt";
	        File filename = new File(pathname);
		          InputStreamReader reader = new InputStreamReader(  
		                  new FileInputStream(filename));  
		           BufferedReader br = new BufferedReader(reader); 
	           String line = "";  
		          line = br.readLine();  
	           while (line != null) {  
		               if (line.equals("List:"))
		               {
		            	   inttype=1;
		               }
		               else if (line.equals("Pattern:"))
		               {
		            	   inttype=2;
		            	   rules=new ArrayList<RuleModel>();
		               }
		               else if (inttype==1)
		               {
		            	  strtemp=line.substring(0,line.indexOf(":"));
		            	  line=line.substring(line.indexOf(":")+1,line.length());
		            	  
		            	  if (!patlist.containsKey(strtemp)) {

		            		  patlist.put(strtemp, new ArrayList<String>());

		                  }
		            	  String[] stritems=line.split(",");
		            	  for (String stritem:stritems)
		            	  {
		                   	  patlist.get(strtemp).add(stritem);
		            	  }	          	  
		               }
		               else if (inttype==2)
		               {
		            	   if (line.startsWith("Class"))
		            	   {
		            		  intclassnum=intclassnum+1;   //start from 0
		            		  if (intclassnum>1)
		            		  {
		            			  rules.add(Ruletemp);
		            		  }
		            		  Ruletemp=new RuleModel();
		            		  Ruletemp.setBelongclass(line.substring(line.indexOf(":")+1,line.length()));
		            		 
		            		 
		            	   }
		            	   else if (line.startsWith("Patternname"))
		            	   {
		            		   intpatternnum=intpatternnum+1;   //start from 0
		            		   if (intpatternnum>1)
			            	   {
			            		 Ruletemp.getPatternRules().add(patternRuleTemp);
			            	   }
		            		   patternRuleTemp=new PatternRuleModel();
		            		   patternRuleTemp.setPatternname(line.substring(line.indexOf(":")+1,line.length()));
		            		   //Patternruletemp.setPatternname(line.substring(line.indexOf(":")+1,line.length()));
		            	   }
		            	   else if (line.startsWith("Words"))
		            	   {
		            		   patternRuleTemp.setWords(line.substring(line.indexOf(":")+1,line.length()).split(","));
		            	   }
		            	   else if (line.startsWith("POS"))
		            	   {
		            		   patternRuleTemp.setPOS(line.substring(line.indexOf(":")+1,line.length()).split(","));
		            	   }
		            	   else if (line.startsWith("Structure"))
		            	   {
		            		   patternRuleTemp.setStructure(line.substring(line.indexOf(":")+1,line.length()).split(","));
		            		   
		            	   }
		            	   
		               }
		               line = br.readLine();
		               
		           }  
	       }
	       catch (Exception e) 
	       {  
	    	   e.printStackTrace();  
	       }
		   Ruletemp.getPatternRules().add(patternRuleTemp);
		   rules.add(Ruletemp);
		   
		   //--------------test---------
		   String output  = "";
			if(rules!=null){
				for(int i=0;i<rules.size();i++){
					RuleModel aModel = (RuleModel)rules.get(i);
					
					output+="i="+i+":"+aModel.toString()+"\n";
				}
			}
			CommonMethod.screenPrint(this.getClass()+",output:"+output);
		   //------------test over------
		   

	}
	//for one sentence and one pattern
	//0 risk,1 result, null dosent match
	public static ArrayList<FactorPairModel> MatchPattern(SentenceRelationModel aSentence, PatternRuleModel aPattern){
		ArrayList<FactorPairModel> rtn = null;
		return rtn;
	}
}

