package clearnlp;

import gate.GateExtractor.EnumProject;
import gate.pattern.CarreRule;
import gate.pattern.FactorModel;
import gate.pattern.FactorPairModel;
import gate.pattern.HotmapRule;
import gate.pattern.PatternRuleModel;
import gate.pattern.RuleBaseEric;
import gate.pattern.RuleBaseWh;
import gate.pattern.RuleModel;
import gate.pattern.FactorModel.activeEnum;
import gate.util.CommonMethod;
import gate.util.GateException;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;


public class SentenceRelationAnalysis {
	private ArrayList<TagModel> riskResult;

	private ArrayList<TagModel> strongSentenceList;
	private ArrayList<TagModel> weakSentenceList;
	
	private EnumProject project;
	
	
	
	private String riskTag = "Risk";
	private String resultTag = "Result";
	private static final String strongTag = "StrongLink";
	private static final String weakTag = "WeakLink";
	
	public SentenceRelationAnalysis(EnumProject project){
		this.project = project;
		if(this.project == EnumProject.Carre){
			this.riskTag  = "Risk";
			this.resultTag = "Result";
			
		}else if(this.project == EnumProject.Hotmap){
			this.riskTag  = "Gene";
			this.resultTag = "Tumor";
		}
		riskResult = new ArrayList<TagModel>();
		
		strongSentenceList = new ArrayList<TagModel>();
		weakSentenceList = new ArrayList<TagModel>();
	}
	
	/*
<table style="width:100%" id="t01">
<caption>knowledges extracted</caption>
  <tr>
    <th>unknown Knowledge</th>
    <td>
		<ol>
			<li class='rule'>rule1</li>
			<li class="rule">rule2</li>	
		</ol>
	</td>
  </tr>
  <tr>
    <th>known Knowledge</th>
    <td>
		<ol>
		  <li class="rule">
			rule3
			<ul>
			  <li class="sentence">Cardiovascular disease mortality was, as anticipated, associated with the full range of risk factors under study, including raised blood pressure, smoking, diabetes, physical inactivity
				<ol style="list-style: circle;">
					<li> <span class="risk">Risk: abc &#10136; def &#10136; <span > <span class="result">Result: ghi &#10138; &#x279a;<span></li>
					<li><span class="risk">Risk: abc &#10136; def &#10136; <span > <span class="result">Result: ghi &#10138; &#x279a;<span></li>
				</ol> 
			  </li>
			  <li class="sentence">By contrast, dementia death was related to very few of the cardiovascular disease risk factors: of those classified as modifiable, only smoking was associated with a raised risk and higher levels of non-HDL with a lower risk</li>
			</ul>
		  </li>
		  <li class="rule">rule4</li>
		</ol>
	</td>
  </tr>
</table>
	*/
	//before invoke this method ,collectTags should be done.
	@SuppressWarnings("unchecked")
	public StringBuffer patternAnalysis(){
		StringBuffer rtn = new StringBuffer();
		rtn.append("<p><ol>");
		CommonMethod.screenPrint("in prepareAnalysis");
		if(strongSentenceList.size()>0 || weakSentenceList.size()>0 ){
			try {
				//DepRelParser drInstance = DepRelParser.getInstance();
				ClearnlpDecode cdInstance = ClearnlpDecode.getInstance();
				CommonMethod.screenPrint("in prepareAnalysis strongSentence.size:"+strongSentenceList.size()+",weakSentence.size():"+weakSentenceList.size());
				ComparatorTag comparator=new ComparatorTag();
				Collections.sort(riskResult, comparator);
				//-------------test----------------
				/*CommonMethod.screenPrint("test begin::::::");
				for(int i=0;i<risk.size();i++){
					TagModel aTag = risk.get(i);
					aTag.toString();
				}*/
				//------------test over------------
				//-----------process StrongSentence First--------------
				
				StringBuffer tmpListContent;
				rtn.append("<table style='width:100%' id='t01'><caption>knowledges extracted</caption><tr> <th>unknown Knowledge</th><td>");
				tmpListContent = getPatternAnalysisContent(cdInstance,weakSentenceList);//unknown list
				rtn.append(tmpListContent);
				rtn.append("</td></tr><tr><th>known Knowledge</th><td>");
				tmpListContent = getPatternAnalysisContent(cdInstance,strongSentenceList);//known list
				rtn.append(tmpListContent);
				rtn.append("</td></tr></table>");
				//-------------test-over--
				//weakSentenceRelationVector = fillinRelationWithRiskResult(weakSentenceList,drInstance);
			} catch (GateException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

		}//end of if
		return rtn;
	}

	private StringBuffer getPatternAnalysisContent( ClearnlpDecode cdInstance,ArrayList<TagModel> sentenceList) throws Exception {
		StringBuffer rtn = new StringBuffer();
		//---------prepare parameters -------
		Vector<SentenceRelationModel> sentenceRelationVector = fillinRelationWithRiskResult(sentenceList,cdInstance);
		//@todo invoke pattern analysis

		//doPatternAnalysis(ruleInstance);
		HashMap<String,ArrayList<SentenceRelationModel>> ruleResult;
		ruleResult= doPatternAnalysis(sentenceRelationVector);//known sentence 
		StringBuffer tmpBf0,tmpBf1 ;
		boolean appendFlag = false;
		int counter = 0;
		//-------------prepare output-------
		String sentenceStr;
		for(Iterator it =  ruleResult.keySet().iterator();  it.hasNext(); )  {  //-----------------------------------------loop rule
		    String   keyRule   =   (String)it.next();   
		    ArrayList<SentenceRelationModel> sentanceList   =  (ArrayList<SentenceRelationModel>)ruleResult.get(keyRule);  
		    tmpBf0 = new StringBuffer();
		    
		    rtn.append("<li class='rule'>").append(keyRule);  //append rule
		    CommonMethod.screenPrint("------------under a rule:"+keyRule);
		    if(sentanceList!=null && sentanceList.size()>0){
		    	
		    	tmpBf0.append("<ul>");
		        for(int i=0;i<sentanceList.size();i++){//loop sentence
		        	tmpBf1 = new StringBuffer();
		        	appendFlag = false;
		        	SentenceRelationModel aSentence = (SentenceRelationModel)sentanceList.get(i);
		        	sentenceStr = aSentence.getStringSentence();
		        	CommonMethod.screenPrint("------------------------sentence:"+sentenceStr);
		        	tmpBf1.append("<li class='sentence'>").append(sentenceStr);
		        	ArrayList<FactorPairModel[]> pairList = (ArrayList<FactorPairModel[]>)aSentence.getFactorPairs();
		        	if(pairList.size()>0){
		        		appendFlag = true;
		        		counter ++;
		        		tmpBf1.append("<ol style='list-style: circle;'>");
		            	for(int j=0;j<pairList.size();j++){//loop pairs
		            		FactorPairModel[] pair = (FactorPairModel[])pairList.get(j);
		            		tmpBf1.append("<li>");
		            		for(int k=0;k<2;k++){
		            			FactorPairModel aRiskResultFactor = pair[k];
		            			if(k==0){
		            				tmpBf1.append("<span class='risk'>").append(this.riskTag).append(":");
		            			}else{
		            				tmpBf1.append("<span class='result'>").append(this.resultTag).append(":");
		            			}
		            			CommonMethod.screenPrint("--------------------------------------type:"+aRiskResultFactor.getType());
		            			ArrayList<FactorModel> factorList =  aRiskResultFactor.getFactorModels();
		            			if(factorList!=null && factorList.size()>0){
			            			for(int m=0;m<factorList.size();m++){
			            				FactorModel aFactor = (FactorModel)factorList.get(m);
			            				tmpBf1.append(aFactor.getLabelName());
			            				if(aFactor.getActive()==activeEnum.INCREASE){
			            					tmpBf1.append("&#10138").append(" ");//->
			            				}else if(aFactor.getActive()==activeEnum.DECREASE){
			            					tmpBf1.append("&#10136").append(" ");//<-
			            				}else{
			            					tmpBf1.append(" ,");
			            				}
			            				CommonMethod.screenPrint("---------------------------------------------------"+aFactor.getLabelName()+":"+aFactor.getActive());
			            			}
			            			
		            			}
		            			tmpBf1.append("</span >");
		            		}//for risk resule pair
		            		tmpBf1.append("</li>");
		            		
		            	}//for pairList
		            	tmpBf1.append("</ol> ");
		        	}//if pairList
		        		
		        	if(appendFlag){
		        		tmpBf0.append(tmpBf1);
		        	}
		        	rtn.append("</li>");	//for sentence
		        		
		        }//for sentence
		        tmpBf0.append("</ul>");
		        if(counter>0){
		        	rtn.append(tmpBf0);
		        }
		    }//end of if sentanceList
		    rtn.append("</li>");//for rule
		}  //end of for //-----------------------------------------loop rule
		return rtn;
	}
	/*
	 * to match patterns under a rule,each rule has a label as the hash key.
	 * one sentence may match several patterns ,duplicate sentence may appear under one rule.
	 * so loop rules first, then in a rule, match each pattern to see if it match.
	 * if match, this sentence with some RISK RESULT pairs will be put in the return Hashtable with rule label as key
	 * */
	private HashMap<String,ArrayList<SentenceRelationModel>> doPatternAnalysis(Vector<SentenceRelationModel> sentenceRelationVector) throws Exception {
		HashMap<String,ArrayList<SentenceRelationModel>> rtn = new HashMap<String,ArrayList<SentenceRelationModel>>();
		String exeProject = this.project.toString();//CommonMethod.getProject();
		RuleBaseWh ruleInstance = null;
		if(exeProject.equals(EnumProject.Carre.toString())){
			ruleInstance = CarreRule.getInstance();
		}else if(exeProject.equals(EnumProject.Hotmap.toString())){
			ruleInstance = HotmapRule.getInstance();
		}
		//CarreRule ruleInstance = CarreRule.getInstance();
		List<RuleModel> rules = ruleInstance.getRules();
		RuleModel aRule ;
		String belongTo;
		List<PatternRuleModel> Patternrules;
		PatternRuleModel aPattern;
		SentenceRelationModel paraModel;

		ArrayList<PatternRuleModel> patterns ;
		if(rules !=null ){
			int ruleSize = rules.size();
			CommonMethod.screenPrint("size:"+ruleSize);
			for(int i=0;i<ruleSize;i++){//loop rules to get patterns for each rule
				aRule = (RuleModel)rules.get(i);
				belongTo = aRule.getBelongClass();//label for this group
				ArrayList<SentenceRelationModel> sentenceUnderRule = null;
				//if(belongTo.equals("Strong Prove")){ //@todo templately
					if(sentenceRelationVector!=null && sentenceRelationVector.size()>0){
						sentenceUnderRule = new ArrayList<SentenceRelationModel>();
						for(int k=0;k<sentenceRelationVector.size();k++){//loop sentence, for each sentence check every pattern
							SentenceRelationModel aSentenceRelationModel = new SentenceRelationModel();
							paraModel = (SentenceRelationModel)sentenceRelationVector.get(k);
							aSentenceRelationModel.deepCopy(paraModel);
							Patternrules = aRule.getPatternRules();
							for(int j=0;j<Patternrules.size();j++){//loop patterns ready for invoke
								aPattern = (PatternRuleModel)Patternrules.get(j);
								CommonMethod.screenPrint("in SentenceRelationAnalysis, doPatternAnalysis() before matchPattern:"+aPattern.getClass()); 
								ruleInstance.MatchPattern( aSentenceRelationModel, aPattern);//in the method each pair is added in the FactorPairs
								//ruleInstance.MatchPattern();
							}//end of for patterns
							sentenceUnderRule.add(aSentenceRelationModel);
						}//end of for sentences
					}
				//}
				rtn.put(belongTo, sentenceUnderRule);
			}
			ruleSize = rules.size();
			CommonMethod.screenPrint("------------------rules:"+ruleSize);
			//end of for rules
		}else{//rules ==null
			throw new Exception("rules null in pattern.txt");
		}
		return rtn;
	}
	/*
	 * return Sentences with RISK,RESEULT information
	 * the input parameter is a group of sentences which were analysised by gate
	 * this method will give these sentences depRel infomation
	 * further more, riskResult tags from gate will be added on each word of these sentences
	 * a riskResult tag could be a phase,
	 * */
	private Vector<SentenceRelationModel> fillinRelationWithRiskResult(ArrayList<TagModel> SentenceList,ClearnlpDecode cdInstance) {
		Vector<SentenceRelationModel> rtn = new Vector<SentenceRelationModel>(); 
		TagModel aTagSentence;
		
		for(int i=SentenceList.size()-1;i>=0;i--){//loop sentence from bottom to top
			
			aTagSentence = SentenceList.get(i);
			int start = aTagSentence.start;
			int end = aTagSentence.end;
			String aSentenceContent = aTagSentence.content;
			CommonMethod.screenPrint("in prepareAnalysis aStrongSentence:"+aSentenceContent);
			//--------DR process one sentence a time----------
			SentenceRelationModel aSentenceModel = cdInstance.process( aSentenceContent);// one sentence
			ArrayList<TagModel> cropedRiskResult = cropList(riskResult,start,end);
			
			
			boolean flag = false;
			String sentenceWordContent ;
			SentenceWordModel aSentenceWord ;
			int corsor=0;
			//----------analysis this sentenct from DepRel ------------
			TagModel.typeEnum tType;
			for(int j=0;j<cropedRiskResult.size();j++){//loop risk
				TagModel aRiskResult = (TagModel)cropedRiskResult.get(j);
				String aRRPhase = aRiskResult.getPhase();
				tType = aRiskResult.getType();
				//CommonMethod.screenPrint("prepareAnalysis aRiskResult aRRToken:"+aRRToken+",tType:"+tType.toString());
				for(int k=corsor;k<aSentenceModel.getTheSentence().size();k++){//loop words to find the risk
					//CommonMethod.screenPrint("in prepareAnalysis  k="+k);//in for
					
					String aRRPhaseArr[] = aRRPhase.split(" ");
					if(aRRPhaseArr.length==1){
						aRRPhaseArr = aRRPhase.split("-");
					}
					for(int n=0,p=k;n<aRRPhaseArr.length;n++,p++){//Loop phase to check if match part of sentence
						aSentenceWord = (SentenceWordModel)aSentenceModel.getTheSentence().get(p);
						sentenceWordContent = aSentenceWord.getRaw();
						if(aRRPhaseArr[n].equals(sentenceWordContent)){
							flag = true;
						}else{
							flag = false;
							break;
						}
						
					}
					if(flag){//match
						for(int n=0,q=k;n<aRRPhaseArr.length;n++,q++){
							aSentenceWord = (SentenceWordModel)aSentenceModel.getTheSentence().get(q);	
							if(aSentenceWord.getType()==null){
								aSentenceWord.setType(tType);
							}else if(aSentenceWord.getType()!=tType){//belong to Risk and Result
								aSentenceWord.setType(TagModel.typeEnum.RISKRESULT);
							}
							aSentenceModel.getTheSentence().set(q, aSentenceWord);
						
						//CommonMethod.screenPrint("in prepareAnalysis find a word with type:"+aSentenceModels.get(k).getType()+",corsor:"+corsor);
						}
						corsor = k;
						break;
					}
				}//for loop words
				
			}//loop risk
			//CommonMethod.screenPrint(aSentenceModels.get(16).getType()+","+aSentenceModels.get(26).getType()+","+aSentenceModels.get(43).getType());
			rtn.add(aSentenceModel);// result is stored here
		}//loop sentence
		
		//----------test if SentenceRelationModel is ready-
		CommonMethod.screenPrint("rtn.size():"+rtn.size());
		for(int m=0;m<rtn.size();m++){
			SentenceRelationModel tmpModels = (SentenceRelationModel)rtn.get(m);
			for(int n=0;n<tmpModels.getTheSentence().size();n++){
				SentenceWordModel aSentenceWord = (SentenceWordModel)tmpModels.getTheSentence().get(n);
				//CommonMethod.screenPrint("_____________________in fillinRelationWithRiskResult :"+aSentenceWord.toString());
			}
			
			
		}
		//-----------test over----------------------------
		return rtn;
	}
	//start: sentence Start
	//end: sentence end
	
	private ArrayList cropList(ArrayList<TagModel> list,int start ,int end){
		ArrayList<TagModel> rtn = new ArrayList<TagModel>();
		for(int i=0;i<list.size();i++){
			TagModel aTag = (TagModel)list.get(i);
			int tmpStart = aTag.start;//token start
			int tmpEnd = aTag.end;	
			if(tmpStart>=start&& tmpEnd<=end){
				rtn.add(aTag);
				CommonMethod.screenPrint("sentenct start:"+start+",sentence end:"+end+",token start:"+tmpStart+",token end:"+tmpEnd+" aTag:"+aTag.getPhase());
			}
		}
		return rtn;
	}
	public void collectTags(String type,int start, int end, String content){
		//CommonMethod.screenPrint(this.getClass()+",in collectTags___________type:"+type+",content__________:"+content);
		TagModel tmpModel;
		//String project = CommonMethod.getProject();
		
		if(( (type.contains(this.riskTag)|| type.contains(this.resultTag)) )){//a risk
			//CommonMethod.screenPrint(this.getClass()+",risk result ,in collectTags___________type:"+type+",content__________:"+content+",start:"+start+",end:"+end);
			tmpModel = new TagModel();
			tmpModel.setPhase(content);
			tmpModel.setStart(start);
			tmpModel.setEnd(end);
			if(type.contains(this.riskTag) && !type.contains(this.resultTag)){
				tmpModel.setType(TagModel.typeEnum.RISK);
				//CommonMethod.screenPrint(tmpModel.getPhase()+",start:"+tmpModel.getStart()+",end:"+tmpModel.getEnd());
				riskResult.add(tmpModel);
			}else if(type.contains(this.resultTag) && !type.contains(this.riskTag)){
				tmpModel.setType(TagModel.typeEnum.RESULT);
				//CommonMethod.screenPrint(tmpModel.getPhase()+",start:"+tmpModel.getStart()+",end:"+tmpModel.getEnd());
				riskResult.add(tmpModel);
			}
			else {//both
				tmpModel.setType(TagModel.typeEnum.RISKRESULT);
				//CommonMethod.screenPrint(tmpModel.getPhase()+",start:"+tmpModel.getStart()+",end:"+tmpModel.getEnd());
				riskResult.add(tmpModel);
			}
		}else if(type.contains(SentenceRelationAnalysis.strongTag) || type.contains(SentenceRelationAnalysis.weakTag)){
			
				boolean sentenceFlag = false;
				if(this.project==EnumProject.Carre){
					if(type.startsWith("CA_")){
						sentenceFlag = true;
					}
				}else if(this.project==EnumProject.Hotmap){
					if(type.startsWith("HM_")){
						sentenceFlag = true;
					}
				}
				if(sentenceFlag){
			
					CommonMethod.screenPrint(this.getClass()+",strong weak ,in collectTags___________type:"+type+",content__________:"+content+",start:"+start+",end:"+end);
					tmpModel = new TagModel();
					tmpModel.setContent(content);
					tmpModel.setStart(start);
					tmpModel.setEnd(end);
					if(type.contains(SentenceRelationAnalysis.strongTag)){
						strongSentenceList.add(tmpModel);
					}else{
						weakSentenceList.add(tmpModel);
					}
					
				}//end of if(sentenceFlag)
		}//end of if type.contains
	}//end of collectTags
	
	
	
	

	
	void setStrongSentence(ArrayList<TagModel> sentence){
		this.strongSentenceList = sentence;
	}
	void setWeakSentence(ArrayList<TagModel> sentence){
		this.weakSentenceList = sentence;
	}
	
	
	public ArrayList<TagModel> getStrongSentence(){
		return this.strongSentenceList;
	}
	public ArrayList<TagModel> getWeakSentence(){
		return this.weakSentenceList;
	}
	
	
	
}
