package gate;

import gate.util.GateException;
import gate.*;
import gate.GateParser.SortedAnnotationList;
import gate.creole.*;
import gate.util.*;
import gate.util.persistence.PersistenceManager;
import gate.corpora.RepositioningInfo;
import java.io.File;
import java.io.IOException;

public class GateInstance {
	
	///private String pluginsHome;
	private static GateInstance instance = null;
	
	private GateInstance(){
		
		//pluginsHome = "D:"+File.separator+"tools"+File.separator+"Gate"+File.separator+"gate-7.0-build4195-BIN"+File.separator+"plugins";
		//pluginsHome = "D:"+File.separator+"tools"+File.separator+"Gate"+File.separator+"gate-8.0-build4825-ALL"+File.separator+"plugins";
		//System.setProperty("gate.plugins.home",pluginsHome);
		init();
	}
	public static GateInstance getInstance() throws GateException, IOException{
		if(instance==null){
			instance = new GateInstance();
		}
		return instance;
	}
	
	private void init(){
		try {
			//Gate.setGateHome(arg0);
			Gate.init();
			File gateHome = Gate.getGateHome();
			File pluginsHome = new File(gateHome, "plugins");
			CommonMethod.screenPrint(pluginsHome.getPath());
			//-------------gate register
			Gate.getCreoleRegister().registerDirectories(new File(pluginsHome, "ANNIE").toURL());
			Gate.getCreoleRegister().registerDirectories(new File(pluginsHome, "Gazetteer_Ontology_Based").toURL());
			Gate.getCreoleRegister().registerDirectories(new File(pluginsHome, "Ontology").toURL());
			Gate.getCreoleRegister().registerDirectories(new File(pluginsHome, "Tools").toURL());
			Gate.getCreoleRegister().registerDirectories(new File(pluginsHome, "Ontology_Tools").toURL());
			
			
		} catch (GateException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch(IOException e){
			e.printStackTrace();
		}
	}
}
