package gate;

import gate.GateExtractor.EnumMode;
import gate.GateExtractor.EnumProject;
import gate.GateExtractor.SortedAnnotationList;
import gate.HtmlModel.startEndFlagEnum;
import gate.corpora.RepositioningInfo;
import gate.creole.ResourceInstantiationException;
import gate.pattern.ArgsModel;
import gate.pattern.ArgslistModel;
import gate.pattern.CarreRule;
import gate.pattern.HotmapRule;
import gate.pattern.RuleBaseEric;
import gate.pattern.RuleBaseWh;
import gate.util.CommonMethod;
import gate.util.GateException;
import gate.util.GenerateResultFile;
import gate.util.RandomColour;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.net.MalformedURLException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collections;
import java.util.Enumeration;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Set;

import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CreationHelper;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.ss.util.WorkbookUtil;

import clearnlp.ClearnlpDecode;
import clearnlp.DepRelParser;
import clearnlp.SentenceRelationAnalysis;
import clearnlp.SentenceRelationModel;
import clearnlp.SentenceWordModel;
import clearnlp.TagModel;
import model.TrainingExcelModel;
import model.TrainingModel;
import model.db.TrainingPaperModel;
import model.db.TrainingPhraseModel;
import model.db.TrainingSentenceModel;
import util.DBAccess;
import util.FileLister;
import util.PaperXmlParser;

public class GateTraining {
	
	
	private Workbook wBook ;  // or new XSSFWorkbook();
	private Sheet sentenceSheet ;
	private Sheet phraseSheet ;
	private Sheet paperSheet;
	private short phraseRowCount;
	private short sentenceRowCount;
	private short paperRowcount;
	private String outputExcel="D:\\work\\Gate\\test\\TrainingOutput3.xls";
	private boolean debugMode = false;
	private String dics;
	private statusEnum flag = statusEnum.normal;//normal,init;
	//paper source path is in D:\\work\\Gate\\trainingModel\\papers\\
	private int trainingMode = 0; //all sentence, 1 carre sentence, 2 hotmap sentence
	private Hashtable grpedColourTable;
	
	public GateTraining(){
		wBook = new HSSFWorkbook(); 
		paperSheet = wBook.createSheet("paperTab");
		sentenceSheet = wBook.createSheet("sentenceTab");
		phraseSheet = wBook.createSheet("phraseTab");
		phraseRowCount = 1;
		sentenceRowCount = 1;
		paperRowcount = 1;
	}
	public Workbook getWorkBook(){
		return wBook;
	}
	
	public enum statusEnum{init,normal};
	private Hashtable<String,TrainingExcelModel> docPortionModelTable;

	public static void main(String args[]){
		//main1(); //analysis doc
		//main2();//write Excel
		
		//mainCarre();
		mainCarreOutput();
	}
	public static void mainCarre(){
		
		GateTraining training = new GateTraining();
		training.doWithCarre();
		CommonMethod.screenPrint("mainCarre over");
	}
	public static void mainCarreOutput(){
		GateTraining training = new GateTraining();
		/*
		training.writeTitle(0);
		training.writeTitle(1);
		training.writeTitle(2);
		training.writeTitle(3);
		training.writeTitle(4);*/
		
		//-----------write paper sheet---
				DBAccess aDB = new  DBAccess();
				/*ArrayList<TrainingPaperModel> papDocList = aDB.readPaperDoc();
				training.writePaper(papDocList);
				
				ArrayList<TrainingSentenceModel> senDocList = aDB.readSentenceDoc();
				training.writeSentence(senDocList);
				ArrayList<TrainingPhraseModel> phrDocList = aDB.readPhraseDoc();
				training.writePhrase(phrDocList,"phraseTab");
				ArrayList<TrainingPhraseModel> phrSenDocList = aDB.readPhraseSentenceCombiDoc();
				training.writePhrase(phrSenDocList,"phraseSentenceCombiTab");*/
				
				ArrayList<TrainingSentenceModel> senDocList = aDB.readSentenceDoc();
				training.writeWordsForSentence(senDocList,"wordSentenceCombiTab");/**/
		
	}
	//current run
	public static void main1(){
		
		GateTraining training = new GateTraining();
		//training.writeTitle();
		training.dics = null;
		training.doWith();
		//training.testExcel();
		CommonMethod.screenPrint("main1 over");
		
	}
	public static void main2(){
		GateTraining training = new GateTraining();
		/*training.writeTitle(0);
		training.writeTitle(1);
		training.writeTitle(2);
		training.writeTitle(3);
		
		training.writeTitle(4);*/
		//-----------write paper sheet---
		DBAccess aDB = new  DBAccess();
		
		/*ArrayList<TrainingPaperModel> papDocList = aDB.readPaperDoc();
		training.writePaper(papDocList);
		
		ArrayList<TrainingSentenceModel> senDocList = aDB.readSentenceDoc();
		training.writeSentence(senDocList);
		ArrayList<TrainingPhraseModel> phrDocList = aDB.readPhraseDoc();
		training.writePhrase(phrDocList,"phraseTab");
		ArrayList<TrainingPhraseModel> phrSenDocList = aDB.readPhraseSentenceCombiDoc();
		training.writePhrase(phrSenDocList,"phraseSentenceCombiTab");*/
		/**/
		ArrayList<TrainingSentenceModel> senDocList = aDB.readSentenceDoc();
		training.writeWordsForSentence(senDocList,"wordSentenceCombiTab");
		
	}
	private void doWithCarre(){
		this.flag = statusEnum.init;
		dics = "Carre";//"Hotmap,Carre";
		if(flag ==statusEnum.init){//only need read once;
			preProcessDocCarre();
		}
		flag = statusEnum.normal;
		this.trainingMode = 1;//carre
		doWith();
	}
	private  void doWith() {
		try {
			//--------write excel title------------
			//writeTitle();
			//----------------------------------------
			
			
			
			//-------create files in DB----------
			if(flag ==statusEnum.init){//only need read once;
				preProcessDoc();
			}

			//------------------------------------------
			EnumMode mode = EnumMode.standalong;
			CommonMethod.screenPrint("in GateExtractor step1 mode:"+mode);
			GateInstance.getInstance();
			CommonMethod.screenPrint("in GateExtractor step2 GateInstance");
		
			//------read property file next
			//----------GATE init PR ------------------------
			PipelineFactory.initProcessingResouces(mode);
			CommonMethod.screenPrint("in GateExtractor step3 initProcessingResouces");
			//----------------
			GateExtractor extObj = new GateExtractor( null,null,mode);//( grammar,keyWords,mode)0 for stand alone
			//extObj.setTestFile(testFile);
			extObj.initSerialAnnieNew(dics);//null, (dics);//AssembleProcessingResource
			
			CommonMethod.screenPrint("in GateExtractor step4 initSerialAnnieNew");
			Corpus corpus = Factory.newCorpus("GateParser corpus");
			//corpus.clear();

			//createFile(corpus,null,null);//add file in corpus
			//we got docPortionModelTable from DB with corpus setting documents;
			//hashKey = sId+"-"+paperPortion;
			
			//----------view of paper-:emit([doc.typeName,doc.title], fNames);------------------------
			String designView = "paper/paperAttachmentWithTitle";//"paper/paperAttachment";
			setDocPortionModelTable( createCorpusDocumentsFromDB(corpus,designView));//dbType temp null
			//key: sId+"-"+paperPortion; model:pId,url,folderName,title
			//---------------------------------------------------------------------------------------
			// tell the pipeline about the corpus and run it
			//if(getDocPortionModelTable().size() == corpus.size() && corpus.size() >0 ){
			if( corpus.size() >0 ){
				extObj.setCorpus(corpus);
				SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.S");
	            CommonMethod.screenPrint("before: " + dateFormat.format(Calendar.getInstance().getTime()));
	            extObj.execute();
	            CommonMethod.screenPrint("after execute: " + dateFormat.format(Calendar.getInstance().getTime()));
				
				String rAbspath ;
				rAbspath= processDoc(corpus);//processDoc(corpus,project,0);//0 useless
				
				CommonMethod.screenPrint("\n ...............rAbspath:"+rAbspath);				
			}
			
			   //------------write output excel--------------
					/*FileOutputStream out = new FileOutputStream(outputExcel);
					getWorkBook().write(out);
					out.close();
					CommonMethod.screenPrint("in GateTraining process over");*/
			CommonMethod.screenPrint("in GateTraining doWith over");

		} catch (ResourceInstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (GateException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		catch(Exception e){
			e.printStackTrace();
			CommonMethod.screenPrint("Exception from GateExtractor in main4:"+e.getMessage());
		}
	}
	//-------------add required tags------------
	private HashSet getTagsForAnnotationSet(){
		
		HashSet rtn = new HashSet(); //annotTypesRequired
		//-----------
		if(this.trainingMode==0){
			rtn.add("Sentence");
		}else if(this.trainingMode==1){
			
			
			 // 	CA_PositiveStrongLinkTag
			//	CA_NegativeStrongLinkTag
			//	CA_PositiveWeakLinkTag
			//	CA_NegativeWeakLinkTag
			//	CA_NewRiskLinkTag
			rtn.add("Sentence");
			rtn.add("CA_PositiveStrongLinkTag");
			rtn.add("CA_NegativeStrongLinkTag");
			rtn.add("CA_PositiveWeakLinkTag");
			rtn.add("CA_NegativeWeakLinkTag");
			rtn.add("CA_NewRiskLinkTag");
		}
	    //-------for test--
	    //rtn.add("Lookup");
		return rtn;
	}
	
	/*private HashSet getTagsForAnnotationSet(){
		
		HashSet rtn = new HashSet(); //annotTypesRequired
		//-----------
		
		String aKey;
		 // Get all keys
	    for (Enumeration grpKeys = grpedColourTable.keys(); grpKeys.hasMoreElements();)
	    {
			Hashtable subTagTable =(Hashtable) grpedColourTable.get(grpKeys.nextElement());//domain table or keyword table
			for(Enumeration tagKeys = subTagTable.keys(); tagKeys.hasMoreElements();){
				aKey = (String)tagKeys.nextElement();
				//CommonMethod.screenPrint("in getTagsForAnnotationSet:"+aKey+",aKey.length:"+aKey.length());
				rtn.add(aKey);
			}
	    }
	    //-------for test--
	    //rtn.add("Lookup");
		return rtn;
	}*/
	//write DB with paperInfo,SentenceInfo and analysisInfo
	public String processDoc(Corpus corpus) throws IOException,Exception {
		
		Hashtable<String,TrainingExcelModel>  docTable = getDocPortionModelTable();
		//key: sId+"-"+paperPortion; model:pId,url,folderName,title
		
		// for each document, get an XML document with the
		// person and location names added
		String rtn = null;//return new generated result fileName
		Iterator docIter = corpus.iterator();

		//grpedColourTable = RandomColour.getGrpTagsWithColour("",EnumProject.Carre);//generate colour table for further use
		//getRequiredTags
		HashSet annotTypesRequired = getTagsForAnnotationSet(); //include domainTags and keywordTags
		
		
		String strLink,docKey,portion,docId;
		while(docIter.hasNext()) {//loop doc files
		    Document doc = (Document) docIter.next();
		    strLink = doc.getParameterValue("sourceUrl").toString();
		    CommonMethod.screenPrint("strLink:"+strLink);
		    //get id and fileName from URL
		    docKey = getDocKeyFromUrl(strLink);//id-portion
		    
		    TrainingExcelModel docModel = docTable.get(docKey);
		    
		    portion = docModel.getPaperPortion();
		    docId = docModel.getPid();

		    //-----------------------------
		    AnnotationSet defaultAnnotSet = doc.getAnnotations();
		    //--------------test tags from Gate---------------
		    Iterator annosTest = defaultAnnotSet.iterator();
		    Annotation testA;
		    while(annosTest.hasNext()) {
		    	testA = (Annotation) annosTest.next();
		    	CommonMethod.screenPrint("***********"+testA.getType()+","+testA.getFeatures().toString());
		    }
		    //-----------------test over---------
		    
		    Set<Annotation> annos = new HashSet<Annotation>(defaultAnnotSet.get(annotTypesRequired));
		    FeatureMap features = doc.getFeatures();
		    String originalContent = (String)features.get(GateConstants.ORIGINAL_DOCUMENT_CONTENT_FEATURE_NAME);
		    RepositioningInfo info = (RepositioningInfo)features.get(GateConstants.DOCUMENT_REPOSITIONING_INFO_FEATURE_NAME);
		
		   // Out.prln("File name: '"+file.getAbsolutePath()+"'");
		    
		    if(originalContent != null && info != null) {

		    	//Out.prln("OrigContent and reposInfo existing. Generate file...");	
		    	Iterator annosIt = annos.iterator();
		    	Annotation currAnnot;
		    	SortedAnnotationList sortedAnnotations = new SortedAnnotationList(info);
		    	int testCount = 0;
		    	long tmpAnnotStart,tmpAnnotEnd;
		    	while(annosIt.hasNext()) {
		    		currAnnot = (Annotation) annosIt.next();
		    		sortedAnnotations.addSortedExclusive(currAnnot);
		    	} // while
		    	CommonMethod.screenPrint("testCount:"+testCount);
		    	StringBuffer editableContent = new StringBuffer(originalContent);
		    	
		    	//add tags in the content and extract knowledge from special tags
		    	//output sentenct
		    	boolean tagFlag =  tagAnnotation(sortedAnnotations,editableContent,info,docModel);//docModel:model:pId,url,folderName,title
		  
		    	String resultFilePath = CommonMethod.readProperties().getProperty(CommonMethod.ResultFilePath).trim();
		    	
		    } // if - should generate

		} // while for each doc
		

		return rtn;
	}

	private String getDocKeyFromUrl(String strLink) {
		String lastPart = DBAccess.getSubStringFromDBURI(strLink);
		lastPart = lastPart.substring(0, lastPart.indexOf("."));
		lastPart = lastPart.replace("/", "-");
		CommonMethod.screenPrint(lastPart);
		return lastPart;
	}
	////docModel:model:pId,url,folderName,title
	private boolean tagAnnotation(SortedAnnotationList sortedAnnotations, StringBuffer editableContent, RepositioningInfo info,TrainingExcelModel docModel){
		boolean rtn = true;
		
		int annotSize = sortedAnnotations.size();
		
		Annotation currAnnot;
		StringBuffer editableContentCopy = new StringBuffer(editableContent);
		SentenceRelationAnalysis srA ;
		
		long insertPositionEnd;
		long insertPositionStart;
		String anntype,content;
		DBAccess aDB = new  DBAccess();
		
		//writeTitle(1);
		Sheet sTab = getWorkBook().getSheet("sentenceTab");
		//-------------------------------------------------------
		for (int i = annotSize - 1,j=0; i >= 0; --i,j++) {//Loop sentence annotation
			currAnnot = (Annotation) sortedAnnotations.get(i);
	        //--------------------deal with this annot
			insertPositionStart = currAnnot.getStartNode().getOffset().longValue();
			insertPositionStart = info.getOriginalPos(insertPositionStart);
			
			insertPositionEnd = currAnnot.getEndNode().getOffset().longValue();
			insertPositionEnd = info.getOriginalPos(insertPositionEnd, true);
		
			//annotation found
			if (insertPositionEnd != -1 && insertPositionStart != -1) {
				//-----process tag
				anntype = currAnnot.getType();//type
				
				content = editableContentCopy.substring((int)insertPositionStart,(int)insertPositionEnd);//content
				TagModel tmpModel;
				//---------style class-------
				
				tmpModel = new TagModel();
				tmpModel.setContent(content);
				tmpModel.setStart((int)insertPositionStart);
				tmpModel.setEnd((int)insertPositionEnd);	
				tmpModel.setTagName(anntype);
				//----------write db with sentence Info
				String  sentenceId = null;
				if(!debugMode){
					sentenceId = aDB.saveSentenceModel(docModel,tmpModel);//save one sentence
				}
				//-----------write sentence sheet in Excel
				/*
				Row row = sTab.createRow((short)j);
				row.createCell(1).setCellValue(j+1);//FolderName
				row.createCell(2).setCellValue(docModel.getPid());//pid
				row.createCell(3).setCellValue(docModel.getPaperPortion());//Abstract
				row.createCell(4).setCellValue(tmpModel.getStart());
				row.createCell(5).setCellValue(tmpModel.getEnd());
				row.createCell(6).setCellValue(tmpModel.getContent());*/
				//-----------------------------------------

				try {
					//DepRelParser drInstance = DepRelParser.getInstance();
					ClearnlpDecode cdInstance = ClearnlpDecode.getInstance();
					
					CommonMethod.screenPrint("in prepareAnalysis aStrongSentence:"+content);
					//--------DR process one sentence a time----------
					SentenceRelationModel aSentenceModel = cdInstance.process( content);// one sentence

					
					//-----------invoke eric's method to write Excel/DB
					analysisSentence(aSentenceModel,sentenceId);
					//----------------------------
					//---------------------------------------------------------------------
				} catch (  IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				//write aSentenceModel into Excel
				
				//---------------list add finished
			}//end of if
		}//end of for annotation	
		return rtn;
	}
	
	
	
	private boolean outputExcel(){
		
		boolean rtn = false;
		
		try {
		
			Workbook wb = new HSSFWorkbook();  // or new XSSFWorkbook();
			Sheet sheet1 = wb.createSheet("new sheet");
			Sheet sheet2 = wb.createSheet("second sheet");

		// Note that sheet name is Excel must not exceed 31 characters
		// and must not contain any of the any of the following characters:
		// 0x0000
		// 0x0003
		// colon (:)
		// backslash (\)
		// asterisk (*)
		// question mark (?)
		// forward slash (/)
		// opening square bracket ([)
		// closing square bracket (])

		// You can use org.apache.poi.ss.util.WorkbookUtil#createSafeSheetName(String nameProposal)}
		// for a safe way to create valid names, this utility replaces invalid characters with a space (' ')
			String safeName = WorkbookUtil.createSafeSheetName("[O'Brien's sales*?]"); // returns " O'Brien's sales   "
			Sheet sheet3 = wb.createSheet(safeName);

		FileOutputStream fileOut = new FileOutputStream("D:\\work\\test\\workbook3.xls");
		wb.write(fileOut);
		fileOut.close();
		
		

	 
			Workbook wb2 = new HSSFWorkbook();
			//Workbook wb = new XSSFWorkbook();
			CreationHelper createHelper = wb2.getCreationHelper();
			Sheet sheet = wb2.createSheet("new sheet");

			// Create a row and put some cells in it. Rows are 0 based.
			Row row = sheet.createRow((short)0);
			// Create a cell and put a value in it.
			Cell cell = row.createCell(0);
			cell.setCellValue(1);

			// Or do it on one line.
			row.createCell(1).setCellValue(1.2);
			row.createCell(2).setCellValue( createHelper.createRichTextString("This is a string"));
			row.createCell(3).setCellValue(true);

			// Write the output to a file
			FileOutputStream fileOut2 = new FileOutputStream("D:\\work\\test\\workbook2.xls");
			wb2.write(fileOut2);
			fileOut2.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return rtn;
	}

	
	private boolean analysisSentence(SentenceRelationModel aSentenceModel, String sentenceId){
		RuleBaseWh ruleInstance = null;
		String exeProject = EnumProject.Hotmap.toString();//CommonMethod.getProject();
		if(exeProject.equals(EnumProject.Carre.toString())){
			ruleInstance = CarreRule.getInstance();
		}else if(exeProject.equals(EnumProject.Hotmap.toString())){
			ruleInstance = HotmapRule.getInstance();
		}
		//ruleInstance.Extraxtinf(aSentenceModel);
		ruleInstance.Extraxtinf(aSentenceModel);
		
		boolean flag = savePhraseDoc2(aSentenceModel,sentenceId);

		return flag;
	}
	private boolean savePhraseDoc2(SentenceRelationModel aSentenceModel,String sentenceId){
		boolean flag = false;
		
		ArrayList<ArgslistModel> argsListModels;
		ArrayList<ArgsModel> argsModels;
		DBAccess dbA = new DBAccess();
		ArrayList<TrainingPhraseModel> tmpList = new ArrayList<TrainingPhraseModel>();		
		
		TrainingPhraseModel trainModel;
		if(aSentenceModel!=null){
			argsListModels = aSentenceModel.getArgslist();
			if(argsListModels!=null){
				//for(ArgslistModel aa: argsListModels){
				for(int i = 0;i<argsListModels.size();i++){
					ArgslistModel aArgsList = argsListModels.get(i);

					argsModels = aArgsList.getArgsModels();
					if(argsModels !=null){
						
						//writeTitle(2);
						//Sheet phraseTab = getWorkBook().getSheet("phraseTab");
						//--------------------
						for(int j=0;j<argsModels.size();j++){
							trainModel = new TrainingPhraseModel(CommonMethod.UuidGenerator(),"TrainingPhraseModel");
							trainModel.setLevel(aArgsList.getlevel()+"");
							trainModel.setPredict(aArgsList.getpredict());
							trainModel.setPos(aArgsList.getpos());
							
							ArgsModel aArgs = argsModels.get(j);
							trainModel.setStartID(aArgs.getStartID()+"");
							trainModel.setEndId(aArgs.getEndID()+"");
							trainModel.setCore(aArgs.getCore());
							trainModel.setComponent(aArgs.getCom());
							trainModel.setArgs(aArgs.getArgs());
							trainModel.setPhrase(aArgs.getPhr());
							trainModel.setPhraseID(aArgs.getPhrID()+"");
							//CommonMethod.screenPrint("aArgs.getPhrID():"+aArgs.getPhrID()+",aArgs.getPaID():"+aArgs.getPaID());
							trainModel.setParentPhraseId(aArgs.getPaID()+"");
							trainModel.setSentenceId(sentenceId);
							if(trainModel.getPredict()!=null && trainModel.getPredict().equals("analyze")){
								CommonMethod.screenPrint("predict:"+trainModel.getPredict()+",core:"+trainModel.getCore()+",component:"+trainModel.getComponent());
							}
							tmpList.add(trainModel);
						}
					}
				}
			}
		}
		
		//----------sort----------------
		ComparatorPhrase comparator=new ComparatorPhrase();
		Collections.sort(tmpList, comparator);
		//----------------------------
		
		int curLevel=0,tmpLevel,count=0;
		int ts,te,ss,se;
		//ArrayList<TrainingPhraseModel> initSameLevelModels = new ArrayList<TrainingPhraseModel>();
		ArrayList<TrainingPhraseModel> sameLevelModels = null;
		ArrayList<TrainingPhraseModel> upperLevelModels = null;
		for(TrainingPhraseModel aTmpPhrase:tmpList){
			tmpLevel = Integer.parseInt(aTmpPhrase.getLevel());
			if(curLevel!=tmpLevel){
				upperLevelModels = sameLevelModels;
				sameLevelModels = new ArrayList<TrainingPhraseModel>();
			}	
				
			if(upperLevelModels !=null){
				for(TrainingPhraseModel aSame:upperLevelModels)
				{
						ts = Integer.parseInt(aTmpPhrase.getStartID());
						te = Integer.parseInt(aTmpPhrase.getEndId());
						ss = Integer.parseInt(aSame.getStartID());
						se = Integer.parseInt(aSame.getEndId());
						if(ss<=ts && se>=te){//contains parent
							aTmpPhrase.setParentPhraseId(aSame.getPhraseID());
						}
				}
					
			}
			curLevel = tmpLevel;
			
			
			sameLevelModels.add(aTmpPhrase);
			curLevel = tmpLevel;
			
			if(!debugMode){
				dbA.saveTrainingPhrase(aTmpPhrase);
			}
		}//endof for
		
		flag=true;
		return flag;
	}
	private boolean savePhraseDoc(SentenceRelationModel aSentenceModel,String sentenceId){
		boolean flag = false;
		ArrayList<ArgslistModel> argsListModels;
		ArrayList<ArgsModel> argsModels;
		DBAccess dbA = new DBAccess();		
		
		TrainingPhraseModel trainModel;
		if(aSentenceModel!=null){
			argsListModels = aSentenceModel.getArgslist();
			if(argsListModels!=null){
				//for(ArgslistModel aa: argsListModels){
				for(int i = 0;i<argsListModels.size();i++){
					ArgslistModel aArgsList = argsListModels.get(i);

					argsModels = aArgsList.getArgsModels();
					if(argsModels !=null){
						
						//writeTitle(2);
						//Sheet phraseTab = getWorkBook().getSheet("phraseTab");
						//--------------------
						for(int j=0;j<argsModels.size();j++){
							trainModel = new TrainingPhraseModel(CommonMethod.UuidGenerator(),"TrainingPhraseModel");
							trainModel.setLevel(aArgsList.getlevel()+"");
							trainModel.setPredict(aArgsList.getpredict());
							trainModel.setPos(aArgsList.getpos());
							
							ArgsModel aArgs = argsModels.get(j);
							trainModel.setStartID(aArgs.getStartID()+"");
							trainModel.setEndId(aArgs.getEndID()+"");
							trainModel.setCore(aArgs.getCore());
							trainModel.setComponent(aArgs.getCom());
							trainModel.setArgs(aArgs.getArgs());
							trainModel.setPhrase(aArgs.getPhr());
							trainModel.setPhraseID(aArgs.getPhrID()+"");
							//CommonMethod.screenPrint("aArgs.getPhrID():"+aArgs.getPhrID()+",aArgs.getPaID():"+aArgs.getPaID());
							trainModel.setParentPhraseId(aArgs.getPaID()+"");
							trainModel.setSentenceId(sentenceId);
							if(trainModel.getPredict()!=null && trainModel.getPredict().equals("analyze")){
								CommonMethod.screenPrint("predict:"+trainModel.getPredict()+",core:"+trainModel.getCore()+",component:"+trainModel.getComponent());
							}
							if(!debugMode){
								dbA.saveTrainingPhrase(trainModel);
							}
							//-----------write phrase sheet in Excel----
							/*Row row = phraseTab.createRow((short)phraseRowCount);
							row.createCell(0).setCellValue(phraseRowCount);//FolderName
							row.createCell(1).setCellValue(trainModel.getSentenceId());//pid
							row.createCell(2).setCellValue(trainModel.getStartID());//Abstract
							row.createCell(3).setCellValue(trainModel.getEndId());
							row.createCell(4).setCellValue(trainModel.getPredict());
							row.createCell(5).setCellValue(trainModel.getPos());
							row.createCell(6).setCellValue(trainModel.getComponent());
							row.createCell(7).setCellValue(trainModel.getCore());
							row.createCell(8).setCellValue(trainModel.getArgs());
							row.createCell(9).setCellValue(trainModel.getPhrase());
							row.createCell(10).setCellValue(trainModel.getParentPhraseId());
							row.createCell(11).setCellValue(trainModel.getLevel());
							phraseRowCount++;*/
							//-------------------
						}
					}
				}
			}
		}
		

		flag=true;
		return flag;
		
	}
	//create documents for corpus from db  by given design view 
	private Hashtable<String,TrainingExcelModel> createCorpusDocumentsFromDB(Corpus corpus,String designView)throws MalformedURLException,ResourceInstantiationException{
		Hashtable<String,TrainingExcelModel> rtn = null;
		boolean flag = false;
		ArrayList<String> docUrl = null;
		DBAccess aDB = new  DBAccess();
		//hashKey = sId+"-"+paperPortion;
		Hashtable<String,TrainingExcelModel> docPortionModelTable = aDB.readPaperAttachment(designView);//"paper/paperAttachment"
		//sId+"-"+paperPortion; model:pId,url,folderName,title
		String sUrl = "";
		TrainingExcelModel teModel;
		String paperPortionKey;//"id-portion"
		
		
		//writeTitle(0);
		//Sheet aPaper = getWorkBook().getSheet("paperTab");
		//------------write output excel--------------
		

		for (Enumeration pportionKeys = docPortionModelTable.keys(); pportionKeys.hasMoreElements();)
	    {
			paperPortionKey = (String)pportionKeys.nextElement();
			if(paperPortionKey.contains("Abstract")){//dealwith Abstract only @todo
				teModel = (TrainingExcelModel)docPortionModelTable.get(paperPortionKey);
/*				Row pRow = aPaper.createRow(this.paperRowcount);
				pRow.createCell(0).setCellValue(teModel.getPid());//FolderName
				pRow.createCell(1).setCellValue(teModel.getFolderName());//pid
				pRow.createCell(2).setCellValue(teModel.getTitle());
				pRow.createCell(3).setCellValue(teModel.getPaperPortion());
*/	
				
		        if(sUrl !=null){
					FeatureMap params = Factory.newFeatureMap();
					params.put("sourceUrl", teModel.getUrl()); //.../180c4bdc_6210_47f6_a3e4_69fd800359d7/RelatedWork.html
					params.put("preserveOriginalContent", new Boolean(true));
					params.put("collectRepositioningInfo", new Boolean(true));
					params.put("markupAware", new Boolean(true));
					params.put("encoding", "UTF-8");
					
					//Out.prln("Creating doc for " + u);
					Document tmpDoc = (Document)Factory.createResource("gate.corpora.DocumentImpl", params);
					//CommonMethod.screenPrint("uuid in document:"+tmpDoc.getParameterValue("uuid"));
					corpus.add(tmpDoc);
		        }
			}
	        paperRowcount++;
		}
		
		flag = true;
		if(flag){
			rtn = docPortionModelTable;
		}
		return rtn;
		
	}
	
	public boolean preProcessDocCarre(){
		Hashtable filesTable = readFolderCarre();//read training folder get subfolders and name and files name//
		boolean flag;
		//db-carre
		DBAccess dbA = new DBAccess();
		dbA.removeAllDocModel();
		dbA.removeAllPhraseModel();
		dbA.removeAllSentenceModel();
		//----------------------
		if(filesTable !=null){
			Enumeration<String> enumKey = filesTable.keys();//folder names
			while(enumKey.hasMoreElements()) {
			    String folder = enumKey.nextElement();//a folder name
			    ArrayList val = (ArrayList)filesTable.get(folder);//files
			    if(val!= null){
			    	for(int i=0;i<val.size();i++){//loop files
			    		String aFile = (String)val.get(i); //name of a file
			    		//each file is mapped to a model 
			    		String docId =  CommonMethod.UuidGenerator(); //uuid
			    		TrainingModel tModel = new TrainingModel(docId);
			    		tModel.setPid(docId);                                                                                     //Pid
			    		tModel.setTypeName(folder);//folder name                                                                  //folderName   
			    		
			    		PaperXmlParser xParser = new PaperXmlParser(aFile);
			    		xParser.processDocument();
			    		Hashtable aPaperTable = xParser.getPaperTable();// portions of a paper(abstract,relatedwork,reference)
			    		int eleSize = aPaperTable.size();
			    		CommonMethod.screenPrint("eleSize:"+eleSize);
			    		String pTitle = (String)aPaperTable.get("Title");
			    		tModel.setTitle(pTitle);                                                                                   //title
			    		aPaperTable.remove("Title");//remove title from the table, the rest part will be saved as file
			    		
			    		eleSize = aPaperTable.size();
			    		CommonMethod.screenPrint("eleSize:"+eleSize);
			    		if(!debugMode){
			    			flag = dbA.saveTrainingModel(tModel, aPaperTable); //paperId	forder	title
			    		}
			    	}
			    }
			}
		}
		//2.for every doc in the db process it.
		//3.save it in the excel.
		return true;
	}
	
	//read xml file and save 3 docs for each xml file in DB
	//read data from config.properties
	//TrainingPath = D:\\work\\Gate\\trainingModel\\papers\\
	//remove old docs and insert new docs;
	public boolean preProcessDoc(){
		//1.read xml file save docs in the DB.
		//Hashtable :(folderName,ArrayList<filePath>)
		Hashtable filesTable = readFolder();//read training folder get subfolders and name and files name//
		boolean flag;
		
		DBAccess dbA = new DBAccess();
		dbA.removeAllDocModel();
		dbA.removeAllPhraseModel();
		dbA.removeAllSentenceModel();
		//parse xml file
		if(filesTable !=null){
			Enumeration<String> enumKey = filesTable.keys();//folder names
			while(enumKey.hasMoreElements()) {
			    String folder = enumKey.nextElement();//a folder name
			    ArrayList val = (ArrayList)filesTable.get(folder);//files
			    if(val!= null){
			    	for(int i=0;i<val.size();i++){
			    		String aFile = (String)val.get(i); //name of a file
			    		//each file is mapped to a model 
			    		String docId =  CommonMethod.UuidGenerator(); //uuid
			    		TrainingModel tModel = new TrainingModel(docId);
			    		tModel.setPid(docId);                                                                                     //Pid
			    		tModel.setTypeName(folder);//folder name                                                                  //folderName   
			    		
			    		PaperXmlParser xParser = new PaperXmlParser(aFile);
			    		xParser.processDocument();
			    		Hashtable aPaperTable = xParser.getPaperTable();// portions of a paper(abstract,relatedwork,reference)
			    		int eleSize = aPaperTable.size();
			    		CommonMethod.screenPrint("eleSize:"+eleSize);
			    		String pTitle = (String)aPaperTable.get("Title");
			    		tModel.setTitle(pTitle);                                                                                   //title
			    		aPaperTable.remove("Title");//remove title from the table, the rest part will be saved as file
			    		
			    		eleSize = aPaperTable.size();
			    		CommonMethod.screenPrint("eleSize:"+eleSize);
			    		if(!debugMode){
			    			flag = dbA.saveTrainingModel(tModel, aPaperTable); //paperId	forder	title
			    		}
			    	}
			    }
			}
		}
		//2.for every doc in the db process it.
		//3.save it in the excel.
		return true;
	}
	
	private Hashtable<String,ArrayList> readFolderCarre(){
		String trainingPath = "D:\\work\\Gate\\trainingModel\\papersPairs\\";  //CommonMethod.getTrainingPath(); D:\\work\\Gate\\trainingModel\\papers\\
		FileLister listFilesUtil = new FileLister();
	    ArrayList folders = listFilesUtil.listFolders(trainingPath);
	    Hashtable rtn = null;
	   
	    if(folders!=null ){
	    	int size = folders.size();
	    	String tmpFolder;
	    	String tmpPath;
	    	if(size>0){
	    		rtn = new Hashtable();
	    		//for each folder
		    	for(int i=0;i<size;i++){
		    		ArrayList<String> fileList;
		    		ArrayList<String> pathList = new ArrayList<String>();
		    		tmpFolder = (String)folders.get(i);
		    		tmpPath = trainingPath+tmpFolder+File.separator; //D:\\work\\Gate\\trainingModel\\papers\\+cloth +\\
		    		fileList = listFilesUtil.listFiles(tmpPath);
		    		String tmpFile;
		    		for(int j=0;j<fileList.size();j++){
		    			tmpFile = (String)fileList.get(j);
		    			pathList.add(tmpPath+tmpFile); //D:\\work\\Gate\\trainingModel\\papers\\+cloth +\\cloth1.xml
		    		}
		    		rtn.put(tmpFolder, pathList);		// (folderName,ArrayList<filePath>)
		    	}
	    	}
	    }
		return rtn;
	}
	//read a folder and return url List of docs with folder name
	//path is read from commonMethod "TrainingPath"
	private Hashtable<String,ArrayList> readFolder(){
		String trainingPath = CommonMethod.getTrainingPath(); //D:\\work\\Gate\\trainingModel\\papers\\
		FileLister listFilesUtil = new FileLister();
	    ArrayList folders = listFilesUtil.listFolders(trainingPath);
	    Hashtable rtn = null;
	   
	    if(folders!=null ){
	    	int size = folders.size();
	    	String tmpFolder;
	    	String tmpPath;
	    	if(size>0){
	    		rtn = new Hashtable();
	    		//for each folder
		    	for(int i=0;i<size;i++){
		    		ArrayList<String> fileList;
		    		ArrayList<String> pathList = new ArrayList<String>();
		    		tmpFolder = (String)folders.get(i);
		    		tmpPath = trainingPath+tmpFolder+File.separator; //D:\\work\\Gate\\trainingModel\\papers\\+cloth +\\
		    		fileList = listFilesUtil.listFiles(tmpPath);
		    		String tmpFile;
		    		for(int j=0;j<fileList.size();j++){
		    			tmpFile = (String)fileList.get(j);
		    			pathList.add(tmpPath+tmpFile); //D:\\work\\Gate\\trainingModel\\papers\\+cloth +\\cloth1.xml
		    		}
		    		rtn.put(tmpFolder, pathList);		// (folderName,ArrayList<filePath>)
		    	}
	    	}
	    }
		return rtn;
	}
	public static void main0(){
		GateTraining gTraining = new GateTraining();
		gTraining.preProcessDoc();
	}
	public Hashtable<String,TrainingExcelModel> getDocPortionModelTable(){
		return this.docPortionModelTable;
	}
	public void  setDocPortionModelTable(Hashtable<String,TrainingExcelModel> table){
		this.docPortionModelTable = table;
	}
	public void testExcel(){
		Sheet aPaper = getWorkBook().getSheet("paperTab");
		Row aRow = aPaper.createRow((short)0);
		aRow.createCell(0).setCellValue("this is a String");
		// Write the output to a file
		try {
			FileOutputStream fileOut = new FileOutputStream("D:\\work\\test\\test.xls");
			getWorkBook().write(fileOut);
			fileOut.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	//sentenceModelView
	public void writeSentence(ArrayList<TrainingSentenceModel> sentDocList){
		
		try {
			HSSFWorkbook workbook = null;
			 File file = new File(outputExcel);
			 boolean fileFlag = false;
			 FileInputStream fileIs = null;
			 if(file.exists() && sentDocList!=null){
				 //Get the workbook instance for XLS file 
				 fileIs = new FileInputStream(file);
				 workbook = new HSSFWorkbook(fileIs);
				 Sheet sSheet = workbook.getSheet("sentenceTab");
					//------------write output excel--------------
				 for(int i=0;i<sentDocList.size();i++){
					 TrainingSentenceModel sModel = (TrainingSentenceModel)sentDocList.get(i);
				    CommonMethod.screenPrint(sModel.toString());
					Row sRow = sSheet.createRow(sentenceRowCount);
			
					sRow.createCell(0).setCellValue(sModel.getId());//sId
					sRow.createCell(1).setCellValue(sModel.getPid());//pid
					sRow.createCell(2).setCellValue(sModel.getPapPortion());//Abstract
					sRow.createCell(3).setCellValue(sModel.getStartId());
					sRow.createCell(4).setCellValue(sModel.getEndId());
					sRow.createCell(5).setCellValue(sModel.getSentContent());
					paperRowcount++;
				 }
				fileIs.close();	
				FileOutputStream out;
				out = new FileOutputStream(new File(outputExcel));
				workbook.write(out);
				out.close();
			}//endof if
		}
		catch(Exception e){
				
		}
	}	
	public void writeWordsForSentence(ArrayList<TrainingSentenceModel> sentDocList,String tabName){
		int wordRowcount = 1;
		try {
			HSSFWorkbook workbook = null;
			 File file = new File(outputExcel);
			 boolean fileFlag = false;
			 FileInputStream fileIs = null;
			 if(file.exists() && sentDocList!=null){
				 //Get the workbook instance for XLS file 
				 fileIs = new FileInputStream(file);
				 workbook = new HSSFWorkbook(fileIs);
				 
				 Sheet sWords = workbook.getSheet(tabName);
				//------------write output excel--------------
				 ClearnlpDecode cdInstance = ClearnlpDecode.getInstance();
				 for(int i=0;i<sentDocList.size();i++){
					 TrainingSentenceModel sModel = (TrainingSentenceModel)sentDocList.get(i);
					 String sId = sModel.getId();
					 String content = sModel.getSentContent();
					//--------DR process one sentence a time----------
					SentenceRelationModel aSentenceModel = cdInstance.process( content);// one sentence
					ArrayList<SentenceWordModel> wordModels = aSentenceModel.getTheSentence();
					int wordSize = wordModels.size();
					SentenceWordModel tmpWordModel,sHeadWrodModel;
					//-----------output one line here
					Row wRow = sWords.createRow(wordRowcount);
					wRow.createCell(0).setCellValue(content);//phraseId
					wordRowcount++;
					for (int j=0;j<wordSize;j++) //loop word ArrayList
					{
						tmpWordModel = (SentenceWordModel)wordModels.get(j);
						//---------for each word write one line.
						wRow = sWords.createRow(wordRowcount);
						wRow.createCell(0).setCellValue(sId);//sId
						wRow.createCell(1).setCellValue(tmpWordModel.getId());//wordId
						wRow.createCell(2).setCellValue(tmpWordModel.getRaw());//raw
						wRow.createCell(3).setCellValue(tmpWordModel.getLemma());//lemma
						String pHead = tmpWordModel.getPhead();
						wRow.createCell(4).setCellValue(pHead);//pHead
						int ipHead = Integer.parseInt(pHead);
						if(ipHead>0)
						{sHeadWrodModel = (SentenceWordModel)wordModels.get(ipHead-1);
							wRow.createCell(5).setCellValue(sHeadWrodModel.getRaw());//pHeadWord
							wRow.createCell(6).setCellValue(sHeadWrodModel.getLemma());//pHeadWord
						}
						wRow.createCell(7).setCellValue(tmpWordModel.getDeprel());//relation
						wordRowcount++;
					}//end of for words
						
					//-----------invoke eric's method to write Excel/DB
				 }//end of for sentence
					fileIs.close();	
					FileOutputStream out;
					out = new FileOutputStream(new File(outputExcel));
					workbook.write(out);
					out.close();
				 
			 }//end of if
		}catch (  IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
					//------------write output excel--------------
	}
	public void writePhrase(ArrayList<TrainingPhraseModel> phrasetDocList,String tabName){
		
		try {
			HSSFWorkbook workbook = null;
			 File file = new File(outputExcel);
			 boolean fileFlag = false;
			 FileInputStream fileIs = null;
			 if(file.exists() && phrasetDocList!=null){
				 //Get the workbook instance for XLS file 
				 fileIs = new FileInputStream(file);
				 workbook = new HSSFWorkbook(fileIs);
				 
				 Sheet sPhrase = workbook.getSheet(tabName);
					//------------write output excel--------------
				 for(int i=0;i<phrasetDocList.size();i++){
					 TrainingPhraseModel pModel = (TrainingPhraseModel)phrasetDocList.get(i);
				    CommonMethod.screenPrint(pModel.toString());
					Row pRow = sPhrase.createRow(phraseRowCount);
	
					pRow.createCell(0).setCellValue(pModel.getId());//phraseId
					pRow.createCell(1).setCellValue(pModel.getSentenceId());//sid
					pRow.createCell(2).setCellValue(pModel.getStartID());//Abstract
					pRow.createCell(3).setCellValue(pModel.getEndId());
					pRow.createCell(4).setCellValue(pModel.getPredict());
					pRow.createCell(5).setCellValue(pModel.getPos());
					pRow.createCell(6).setCellValue(pModel.getComponent());
					pRow.createCell(7).setCellValue(pModel.getCore());
					pRow.createCell(8).setCellValue(pModel.getArgs());
					pRow.createCell(9).setCellValue(pModel.getPhrase());
					pRow.createCell(10).setCellValue(pModel.getPhraseID());
					pRow.createCell(11).setCellValue(pModel.getParentPhraseId());
					pRow.createCell(12).setCellValue(pModel.getLevel());
					phraseRowCount++;
					
				 }
				 
				fileIs.close();	
				FileOutputStream out;
				out = new FileOutputStream(new File(outputExcel));
				workbook.write(out);
				out.close();
				 
			}//endof if
		}
		catch(Exception e){
				
		}
	}
	

	
	public void writePaper(ArrayList<TrainingPaperModel> papDocList){
		
		try {
			HSSFWorkbook workbook = null;
			 File file = new File(outputExcel);
			 boolean fileFlag = false;
			 FileInputStream fileIs = null;
			 if(file.exists() && papDocList!=null){
				 //Get the workbook instance for XLS file 
				 fileIs = new FileInputStream(file);
				 workbook = new HSSFWorkbook(fileIs);
				 
				 Sheet pSheet = workbook.getSheet("paperTab");
					//------------write output excel--------------
				 for(int i=0;i<papDocList.size();i++){
					 TrainingPaperModel teModel = (TrainingPaperModel)papDocList.get(i);
				    CommonMethod.screenPrint(teModel.toString());
					Row pRow = pSheet.createRow(paperRowcount);
					pRow.createCell(0).setCellValue(teModel.getPId());//pid
					pRow.createCell(1).setCellValue(teModel.getTypeName());//FolderName
					pRow.createCell(2).setCellValue(teModel.getTitle());//title
					paperRowcount++;
				 }
				 
				fileIs.close();	
				FileOutputStream out;
				out = new FileOutputStream(new File(outputExcel));
				workbook.write(out);
				out.close();
				 
			}//endof if
			 
		}
		catch(Exception e){
				
		}
	}
	//outputExcel
	public void writeTitle(int i){
		
		try {
			HSSFWorkbook workbook;
			 File file = new File(outputExcel);
			 boolean fileFlag = false;
			 FileInputStream fileIs = null;
			 if(file.exists()){
				 //Get the workbook instance for XLS file 
				 fileIs = new FileInputStream(file);
				 workbook = new HSSFWorkbook(fileIs);
				 fileFlag = true;
			 }else{
				 workbook = new HSSFWorkbook();
			 }
			//Get the workbook instance for XLS file 
			if(i==0){
				Sheet aPaper = workbook.createSheet("paperTab");
				Row aRow = aPaper.createRow((short)0);
				aRow.createCell(0).setCellValue("paperId");
				aRow.createCell(1).setCellValue("forder");
				aRow.createCell(2).setCellValue("title");
			}else if(i==1){
				Sheet aSentence = workbook.createSheet("sentenceTab");//getWorkBook().getSheet("sentenceTab");
				Row  bRow = aSentence.createRow((short)0);
				bRow.createCell(0).setCellValue("sentenceId");
				bRow.createCell(1).setCellValue("paperId");
				bRow.createCell(2).setCellValue("portion");
				bRow.createCell(3).setCellValue("startId");
				bRow.createCell(4).setCellValue("endId");
				bRow.createCell(5).setCellValue("tagName");
				bRow.createCell(6).setCellValue("sentence");
			}else if(i==2){
				Sheet aPhrase = workbook.createSheet("phraseTab");
				Row cRow = aPhrase.createRow((short)0);
				cRow.createCell(0).setCellValue("PhraseId");
				cRow.createCell(1).setCellValue("SentenceId");
				cRow.createCell(2).setCellValue("startId");
				cRow.createCell(3).setCellValue("endId");
				cRow.createCell(4).setCellValue("predict");
				cRow.createCell(5).setCellValue("POS");
				cRow.createCell(6).setCellValue("component");
				cRow.createCell(7).setCellValue("core");
				cRow.createCell(8).setCellValue("args");
				cRow.createCell(9).setCellValue("phrase");
				cRow.createCell(10).setCellValue("phraseId");
				cRow.createCell(11).setCellValue("parentPhraseId");
				cRow.createCell(12).setCellValue("level");
				
			}else if(i==3){
				Sheet aPhrase = workbook.createSheet("phraseSentenceCombiTab");
				Row cRow = aPhrase.createRow((short)0);
				cRow.createCell(0).setCellValue("PhraseId");
				cRow.createCell(1).setCellValue("SentenceId");
				cRow.createCell(2).setCellValue("startId");
				cRow.createCell(3).setCellValue("endId");
				cRow.createCell(4).setCellValue("predict");
				cRow.createCell(5).setCellValue("POS");
				cRow.createCell(6).setCellValue("component");
				cRow.createCell(7).setCellValue("core");
				cRow.createCell(8).setCellValue("args");
				cRow.createCell(9).setCellValue("phrase");
				cRow.createCell(10).setCellValue("parentPhraseId");
				cRow.createCell(11).setCellValue("level");
			}else if(i==4){
				Sheet aWord = workbook.createSheet("wordSentenceCombiTab");
				Row cRow = aWord.createRow((short)0);
				cRow.createCell(0).setCellValue("SentenceId");
				cRow.createCell(1).setCellValue("WordId");
				cRow.createCell(2).setCellValue("Word");
				cRow.createCell(3).setCellValue("WordLemma");
				cRow.createCell(4).setCellValue("ToId");
				cRow.createCell(5).setCellValue("ToWord");
				cRow.createCell(6).setCellValue("ToLemma");
				cRow.createCell(7).setCellValue("Relation");
			}
			if(fileFlag){
				fileIs.close();
			}
			FileOutputStream out;
		
			out = new FileOutputStream(new File(outputExcel));
			workbook.write(out);
			out.close();
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}catch (IOException e) {
		    e.printStackTrace();
		}
		   
	}
}

//----------------view-----------------------
/*predict,core,component
 * function(doc) {
	if(doc.docType=="TrainingPhraseModel"){
		
		emit([doc.predict,doc.core,doc.component], 1);
	}
}
function(keys, values, rereduce) {
  return sum(values);
}
 * 
 * */
 /*paperAttachementwithtitle
  * 
  * function(doc) {
	if(doc.pId!=null && doc.docType=="docModel"){
		var fNames =[];
                var i=0;

                 for(fName in  doc._attachments){
                   fNames[i]=fName;
                   i++;
                  }
  		emit([doc.typeName,doc.title], fNames);
	}
	
}
  * 
  * 
  * */
