package gate.jape;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Calendar;
import java.util.StringTokenizer;
import java.util.UUID;
import java.util.Properties;
import java.io.FileInputStream;   
import java.io.FileOutputStream;
import java.util.Vector;

import gate.util.CommonMethod;

public class JapeKeywords {

	 String keyWords,userName,nodeName;
	 String japePath;
	 Vector tagNames;
	 
	public JapeKeywords(String keyWords, String userName, String nodeName){
		
		this.keyWords = keyWords;
		this.userName = userName;
		this.nodeName = nodeName;
		
		
	}//constructor
	
	// rtn uuid without .jape
	public String createKeywordsFile(){
		String rtn = "";
		//String japePath = CommonMethod.readProperties().getProperty(CommonMethod.JapePath).trim();
		String japePath = CommonMethod.getJapePathWrite();
		try {
			 
			String content = "This is the content to write into file";
			String uuid =   CommonMethod.UuidGenerator();
			
			String fileName = uuid;//format2KwordsJape(uuid);//with .jape
			File file = new File(japePath+fileName+".jape");
 
			// if file doesnt exists, then create it
			if (file.exists()) {
				boolean success = file.delete();
				file.createNewFile();
			}
 
			FileWriter fw = new FileWriter(file.getAbsoluteFile());
			BufferedWriter bw = new BufferedWriter(fw);
			StringBuffer sb = getJapeFromKeywords();
			if(sb !=null){
				bw.write(sb.toString());
				bw.close();
				CommonMethod.screenPrint("file:"+fileName+" created under:"+japePath);
				rtn = fileName;
				//rtn= new StringTokenizer(fileName,".").nextToken();
				CommonMethod.screenPrint("rtn:"+rtn);
			}
 
		} catch (IOException e) {
			e.printStackTrace();
		}
		return rtn;
	}


	
	private StringBuffer getJapeFromKeywords(){
		StringBuffer rtn = null;
		
		if(this.keyWords!=null && !this.keyWords.equals("")){
			tagNames = new Vector();
			rtn =  new StringBuffer();
			String phaseName = createPhaseName();
			rtn.append("Phase:").append(phaseName).append("\n");
			rtn.append("Input:").append("Lookup Token Split").append("\n");
			rtn.append("Options:").append("control=appelt").append("\n");
			StringTokenizer st = new StringTokenizer(this.keyWords,",");
			int i=0,j;
			String tmpWordGrp,tmpWord,tmpFirstLetter,tmpWordGrpFmt;
			StringTokenizer st2;
			String tagName;
		    while (st.hasMoreTokens()) {
		    	 tmpWordGrp = st.nextToken();// seperate from ,
		    	 tmpWordGrp = tmpWordGrp.trim();
		    	 tmpWordGrpFmt = JapeKeywords.formatWordGroup(tmpWordGrp);
		    	 
		    	 rtn.append("//------------keywords: ").append(":"+tmpWordGrp).append("\n");
		    	 String keyWordsMacro ="M_"+tmpWordGrpFmt;
		    	 rtn.append("Macro: "+keyWordsMacro).append("\n");
		    	 rtn.append("(\n");
		  
	    		 st2 = new StringTokenizer(tmpWordGrp);//seperate from " "space
	    		 j=0;
	    		 while(st2.hasMoreTokens()){
	    			 tmpWord = st2.nextToken();
	    			 if(j==0){
	    				 tmpFirstLetter = tmpWord.substring(0,1);
	    				 rtn.append("{Token.string==~\"[").append(tmpFirstLetter.toUpperCase()).append(tmpFirstLetter.toLowerCase()).append("]").append(tmpWord.substring(1)).append("\"}").append("\n");
	    			 }else{
	    				 rtn.append("{Token.string==\"").append(tmpWord).append("\"}").append("\n");
	    			 }
	    			 j++;
	    		 }
	    		 rtn.append(")").append("\n");;
	    		 String ruleName = "R_"+tmpWordGrpFmt;
	    		 rtn.append("Rule: "+ruleName).append("\n");
	    		 rtn.append("(").append("\n");
	    		 rtn.append("(").append(keyWordsMacro).append(")").append("\n");
	    		 rtn.append("):match").append("\n");
	    		 rtn.append("-->").append("\n");
	    		 tagName = tmpWordGrpFmt +"Tag";
	    		 tagNames.add(tagName);
	    		 rtn.append(":match.").append(tagName).append("={").append("rule=\"").append(ruleName).append("\"}").append("\n");
		    	 
		         i++;
		     }
		}
		return rtn;
	}
	
	private String createPhaseName(){
		String rtn = "";
		Calendar cal = Calendar.getInstance();
		long timeLong = cal.getTimeInMillis();
		rtn = this.userName+"_"+this.nodeName+"_"+timeLong;
		return rtn;
		
	}
	public static String formatWordGroup(String wordGrp){
		String rtn = wordGrp.trim();
		rtn = wordGrp.replace(" ", "_");
		return rtn;
	}
	
	public  static String format2KwordsJape(String uuid){
		//String formatUuid = uuid.replace("_", "");
		//return "Kwords"+formatUuid+".jape";
		return "Kwords_"+uuid+".jape";
	}
	//keywords: hear cancer, breast cancer
	public static Vector getKeywordTagNames(String keywords){
		Vector rtn = new Vector();
		StringTokenizer st = new StringTokenizer(keywords,",");
		String tmpWordGrp,tagName ;
		while (st.hasMoreTokens()) {
			tmpWordGrp = st.nextToken();// seperate from ,
			tmpWordGrp = tmpWordGrp.trim();
			tmpWordGrp = JapeKeywords.formatWordGroup(tmpWordGrp);
			tagName = tmpWordGrp +"Tag";
			rtn.add(tagName);
		}
		return rtn;
	}
	
	public Vector getKeywordsTagNames(){
		return this.tagNames;
	}
	public static void main(String[] args) {
		JapeKeywords obj = new JapeKeywords(" heart failure , renal dysfunction constitutes, the cardiorenal syndrome","userName","nodeName");
		String fileName = obj.createKeywordsFile();
		CommonMethod.screenPrint("file:"+fileName);
		String fName = obj.format2KwordsJape("aaa_bbb_ddd");
		CommonMethod.screenPrint("fName:"+fName);
		
	}//main
}
