package gate.util;

import gate.GateExtractor;
import gate.GateExtractor.EnumMode;
import gate.GateExtractor.EnumProject;
import gate.pattern.CarreRule;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.Properties;
import java.util.Hashtable;
import java.util.UUID;


public class CommonMethod {
	public static String GatePluginsHome = "GatePluginsHome";
	//public static String JapePath = "JapePath";
	//public static String OntologyPath = "OntologyPath";
	//public static String DicPath = "DicPath";
	public static String Project = "Project";
	public static String TagName = "Tags";
	
	public static String KeywordTagName = "KeywordTags";
	public static String OntologyTagName = "Ontology";
	
	public static String ResultFilePath = "ResultFilePath";
	public static String TmpFilePath = "TmpFilePath";
	public static String TmpFileURL = "TmpFileURL";
	public static String GateCfg = "GateCfg";
	public static String GateCfgPath = "GateCfgPath";
	public static String Ports = "Ports";
	public static String ConfigPath = "D:"+File.separator+"GateConfig"+File.separator+"config.properties";//D:/GateConfig/config.properties
	//public static String ConfigPath = "/home/ccgv/div/gateCfg/config.properties";
	//public static String ConfigPath = "/home/hui/gate/GateConfig/config.properties";//for server use
	public static String NumberFactor = "NumberFactor";
	public static String Mode = "Mode";
	public static String DBProperty = "db.properties";
	public static String TrainingPath="TrainingPath";//nmae in config.properties
	

	public static String getGatePluginsHome(){
		String rtn = getPropertyValue(GatePluginsHome);
		return rtn;
	}
	
	public static void screenPrint(String s){
		System.out.println("from CM:"+s);
	}
	public static void exceptionPrint(String s){
		System.out.println("from CM exception:"+s);
	}
	
	public static Properties  readProperties(){

		Properties rtn = new Properties();
		try {

			
			FileInputStream fis = new FileInputStream(CommonMethod.ConfigPath);
			rtn.load(fis);   
			fis.close();
			//--------------get value
			//CommonMethod.screenPrint("JapePath is :"+rtn.getProperty("JapePath"));
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}catch(Exception e){
			e.printStackTrace();
		}
		return rtn ;
	}
	public static String getDBProperties(){
		return getGateCfgPathWrite()+DBProperty;
	}
	public static String getMode(){
		String rtn = getPropertyValue(Mode);
		return rtn;
	}
	public static String getNumberFactorTag(){
		String rtn = getPropertyValue(NumberFactor);
		return rtn;
	}
	public static String UuidGenerator(){
		UUID uuid = UUID.randomUUID();   
		String rtn = uuid.toString().replace("-", "_");
		return rtn;
	}
	public static String getServerIp(){
		String rtn = "";
		try {
			InetAddress   localhost   =   InetAddress.getLocalHost(); 
			rtn = localhost.getHostAddress();
			screenPrint(rtn);
		} catch (UnknownHostException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
		return rtn;
	}
	public static String getResultFilePath(){
		String rtn =  getPropertyValue(ResultFilePath);
		return rtn;
	}
	public static String getGateCfgPathURL(){
		String ip = getServerIp();
		String gateCfg = getPropertyValue(GateCfg);
		String ports =  getPropertyValue(Ports);
		String rtn="http://"+ip+":"+ports+"/"+gateCfg;
		screenPrint(rtn);
		return rtn;
	}
	public static String getGateCfgPathWrite(){
		String gateCfgPath = getPropertyValue(GateCfgPath);
		return gateCfgPath;
	}
	public static String getJapePathURL(){
		return getGateCfgPathURL()+"jape/"+getDomain()+"/";
	}
	public static String getJapePathWrite(){
		return getGateCfgPathWrite()+"jape"+File.separator+"keywords"+File.separator;
	}
	public static String getKeywordsJapePath(EnumMode mode){
		String rtn = "";
		if(mode == EnumMode.standalong){
			rtn =  getGateCfgPathWrite()+"jape"+File.separator+"keywords"+File.separator;
		}else{
			rtn =  getGateCfgPathURL()+"jape/keywords/";
		}
		return rtn;
	}
	public static String getOntologyPathURL(){
		return getGateCfgPathURL()+"ontology/"+getDomain()+"/";
	}
	public static String getOntologyPathWrite(){
		return getGateCfgPathWrite()+"ontology"+File.separator+getDomain()+File.separator;
	}
	public static String getDicPathURL(){
		return getGateCfgPathURL()+"dic/"+getDomain()+"/";
	}
	public static String getDicPathWrite(){
		return getGateCfgPathWrite()+"dic"+File.separator+getDomain()+File.separator;
	}
	public static String getDomain(){
		String rtn = getPropertyValue("Domain");
		return rtn;
	}
	//------for jape and owl files using same name
	public static String getCarreDomain(){
		String rtn = getPropertyValue("CarreDomain");
		return rtn;
	}
	public static String getChicDomain(){
		String rtn = getPropertyValue("ChicDomain");
		return rtn;
	}
	//with project name
	public static String getOntologyTagValue(){
		String project = getProject();
		String tagname = project+OntologyTagName;
		String rtn = getPropertyValue(tagname);
		return rtn;
	}
	public static String getPropertyValue(String tagname){
		return readProperties().getProperty(tagname).trim();
	}

	public static String getResultFilePathURLByUuid(String uuid){
		String path = CommonMethod.getResultFileURL();
		String rtn = path+"result_"+uuid+".html";
		return rtn;
	}
	public static String getResultFileURL(){
		String rtn = getPropertyValue("ResultFileURL");
		return rtn;
	}
	private String getOntologyFilePathURL(){
		String sProject = CommonMethod.getProject();
		sProject = sProject.trim();
		CommonMethod.screenPrint("project:"+sProject+",len:"+sProject.length());
		EnumProject theProject = EnumProject.valueOf(sProject);
		String rtn = "";
		 rtn = CommonMethod.getOntologyPathURL();//include domainName/
		//String ontologyPath = CommonMethod.readProperties().getProperty(CommonMethod.OntologyPath).trim();
		 switch (theProject) {
		    case Carre: 
		    	rtn += "CarreOntology";//ComputerGraphics.owl
		      break;   
		    case Chic: // fall through to C
		    	rtn += "ChicOntology";
		    	break;
		    case Div: 
		    	rtn += "DivOntology";
		      break;
		  }
		 rtn+= ".owl";
		 return rtn;
	}
	
	public static String getDictionaryPathOwl(String dicName, EnumMode mode){
		String rtn  = getDictionaryPath(dicName,mode)+dicName+".owl";

		return rtn;
	}
	public static String getDictionaryPathPattern(String dicName, EnumMode mode){
		String rtn = getDictionaryPath(dicName,mode)+"pattern.txt";
		return rtn;
	}

	
	public static String getDictionaryPath(String dicName, EnumMode mode){
		String rtn = "";
		
		if(mode == EnumMode.standalong){
			rtn = getGateCfgPathWrite()+"ontology"+File.separator+dicName+File.separator;
		}else{//web
			rtn = getGateCfgPathURL()+"ontology/"+dicName+"/";
		}
		return rtn;
	}
	//-------for dictionarys
	public static String getDictionaryPathJape(String dicName, EnumMode mode){
		String rtn = "";
		
		if(mode == EnumMode.standalong){
			rtn = getGateCfgPathWrite()+"jape"+File.separator+dicName+File.separator+dicName+".jape";
		}else{//web
			rtn = getGateCfgPathURL()+"jape/"+dicName+"/"+dicName+".jape";
		}
		return rtn;
	}
	
	public static String getDictionaries(){
		String rtn = getPropertyValue("Dictionaries");
		return rtn;
	}

	
	//ontology and domain ontology
	public static String getOntoFileNames(){
		String rtn = "";
		String sProject = getProject();
		EnumProject theProject = EnumProject.valueOf(sProject);
		
		 switch (theProject) {
		    case Carre: 
		    	rtn += getCarreDomain()+","+getCarreOntology();
		      break;   
		    case Chic: // fall through to C
		    	rtn += getChicDomain()+","+getChicOntology();;
		    	break;
		    case Div: 
		    	rtn += "";
		      break;
		  }
		 CommonMethod.screenPrint("project:"+sProject+",onto files:"+rtn);
		return rtn;
	}
	public static String getProject(){
		String rtn = getPropertyValue("Project");
		return rtn;
	}
	public static String getCarreOntology(){
		String rtn = getPropertyValue("CarreOntology");
		return rtn;
	}
	public static String getChicOntology(){
		String rtn = getPropertyValue("ChicOntology");
		return rtn;
	}
	
//for training model
	public static String getTrainingPath(){
		String rtn = getPropertyValue(CommonMethod.TrainingPath);
		return rtn;
	}
	public static void main(String args[])throws Exception{
		//------read pattern file first
	
		//------read property file next
		//CommonMethod.readProperties();
		//CommonMethod.getServerIp();
		CommonMethod.getGateCfgPathWrite();
	}
	/*public static String getCarreDomainJape(){
	String rtn = readProperties().getProperty("CarreDomainJape").trim();
	return rtn;
}
	public static String getCarreDomainOnto(){
	String rtn = readProperties().getProperty("CarreDomainOnto").trim();
	return rtn;
}
public static String getChicDomainJape(){
	String rtn = readProperties().getProperty("ChicDomainJape").trim();
	return rtn;
}

public static String getChicDomainOnto(){
	String rtn = readProperties().getProperty("ChicDomainOnto").trim();
	return rtn;
}*/


}
