package model;

import gate.util.CommonMethod;

public class Citation {
	public String cite;
	public String reference;
	public String source;
	public String year;
	public String author;
	public String title;
	public String resId;//resource
	public String resType;// 0 pubmed,1 ieee
	public String id;
	
	public static int lineLength = 140;
	public static String marker = "...";
	
	public Citation() {
		super();
	}


	public Citation(String cite, String reference, String source) {
		super();
		this.cite = cite;
		this.reference = reference;
		this.source = source;
	}

	public String getCite() {
		return cite;
	}

	public void setCite(String cite) {
		this.cite = cite;
	}

	public String getReference() {
		return reference;
	}

	public void setReference(String reference) {
		this.reference = reference;
	}

	public String getSource() {
		return source;
	}

	public void setSource(String source) {
		this.source = source;
	}

	public String getYear() {
		return year;
	}

	public void setYear(String year) {
		this.year = year;
	}

	public String getAuthor() {
		return author;
	}

	public void setAuthor(String author) {
		this.author =  doTrim(author);;
	}

	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {

		this.title = doTrim(title);
	}
	
	public String getResId(){
		return resId;
	}
	public void setResId(String resId) {
		this.resId = resId;
	}
	public String getId(){
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	public String getResType(){
		return resType;
	}
	public void setResType(String resType) {
		this.resType = resType;
	}
	/*
	 * 	public String cite;
	public String reference;
	public String source;
	public String year;
	public String author;
	public String title;
	public String resId;//resource
	public String resType;// 0 pubmed,1 ieee
	public String id;*/
	public String toString(){
		String rtn;
		StringBuffer sb = new StringBuffer();
		sb.append("id="+id+";");
		sb.append("resId="+resId+";");
		sb.append("resType="+resType+";");
		sb.append("title="+title+";");
		sb.append("author="+author+";");
		sb.append("year="+year+";");
		sb.append("source="+source+";");
		sb.append("reference="+reference+";");
		sb.append("cite="+cite+";");
		rtn = sb.toString();
		return rtn;
	}
	public String doTrim(String theStr){
		String rtn = "";
		if(theStr!=null && !theStr.equals("")){
			if(theStr.length()>lineLength){
				rtn = theStr.substring(0,lineLength-marker.length());
				rtn += marker;
				CommonMethod.screenPrint("in doTrim() length:"+theStr.length()+",after:"+rtn.length());
			}else{
				rtn = theStr;
			}
		}
		CommonMethod.screenPrint("theStr:"+theStr+", rtn:"+rtn);
		return rtn;
	}
}
