package resource.api;

import gate.util.Binary2Text;
import gate.util.CommonMethod;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.StringTokenizer;

import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;






import model.Citation;

public class PubmedDataInterface implements DataInterface {
	
		public static String baseUrl= "http://eutils.ncbi.nlm.nih.gov/entrez/eutils/";
		public static String db = "pubmed";
		//public String subUrl;
		public int iRetStart;
		public int iRetMax;
		//public String sTerm;
		public String resType;
		public final String paragraphFlag = "  <p>  ";
		
		
		public PubmedDataInterface(){
			//subUrl = search;
			iRetStart = 0;
			iRetMax = 20;
			//sTerm = term;
			resType = "0";//0 pubmed
			
		}
		//
		//(science cancer) AND 2008  =>(science%20journal)%20AND%20cancel "for advanced"
		//science[journal] cancer 2008 =>science%5Bjournal%5D+cancer+2008
		private String convertKeyWords(String keyWords){
			String rtn = "";
			CommonMethod.screenPrint("in PubmedDataInterface:keyWords:"+keyWords);
			if(keyWords!=null && !keyWords.equals("")){
				StringTokenizer sToken = new StringTokenizer(keyWords);
				String tmpToken = "";
				int num = sToken.countTokens();
				int i=0;
				while (sToken.hasMoreElements()) {
					
					tmpToken = (String)sToken.nextElement();
					rtn+=tmpToken;
					if(i<num-1){
						//rtn+="+AND+";
						rtn+="+";
					}
					i++;
				}
			}
			
			return rtn;
		}
		//return first max set of citation
		//step1
		//http://eutils.ncbi.nlm.nih.gov/entrez/eutils/esearch.fcgi?db=pubmed&usehistory=y&term=heart+attack
		public ArrayList<Citation> processSearch(String keyWords)throws Exception{
			String searchUrl = PubmedDataInterface.baseUrl +"esearch.fcgi?db=pubmed&usehistory=y&term=";
			String term = convertKeyWords(keyWords);
			searchUrl += term;
			
			ArrayList<Citation> rtn = null;
			SearchModel sModel = new SearchModel();
			keyWords = convertKeyWords(keyWords);
			
			URL url = new URL(searchUrl);
		    Document document=this.parse(url);        
		    Element root = document.getRootElement();
		    sModel.idList = new ArrayList();
		    for ( Iterator i = root.elementIterator(); i.hasNext(); ) 
		    {
		            Element row = (Element) i.next();
		            String firstLevelName = row.getName();
		            if(firstLevelName.equals("Count")){
		            	sModel.count = Integer.parseInt(row.getText());
		            }else if(firstLevelName.equals("QueryKey")){
		            	sModel.queryKey = Integer.parseInt(row.getText());
		            }else if(firstLevelName.equals("WebEnv")){
		            	sModel.webEnv = row.getText();
		            }else if(firstLevelName.equals("IdList")){
		            
			            Iterator itr = row.elementIterator();
			            String idValue = "";
			            while(itr.hasNext())
		                {
		                  Element child = (Element) itr.next();
		                  idValue = child.getText();
		                  sModel.idList.add(idValue);
		                  sModel.ids += idValue+",";
		                  //do what ever you want, I will just print
		                  //System.out.println("Element Name:"+child.getQualifiedName()+"  value:"+idValue);
		            
		               }
		            }

		    }//ids is ready now
		    System.out.println("searchModel:"+sModel.toString());
		    
		    rtn = processSummary(sModel.ids);
		    return rtn;
		}
		//return following set of citation
		public ArrayList<Citation> processTurnPage(int pageNum, String webEnv){
			ArrayList<Citation> rtn = null;
			return rtn;
		}
		//get summary for each paper
		//step2
		/*
		 * public String cite;
			public String reference;
			public String source;//pubmed 0,ieee 1,
			public String year;
			public String author;
			public String title;
			public String resId;//resource
			public String resType;// 0 pubmed,1 ieee
			public String id;
		 * */
		/*
		 * format as follows:
		 * <Abstract>
				<AbstractText Label="BACKGROUND" NlmCategory="BACKGROUND">
					With drug treatment for dementia being of limited effectiveness, the role of primary prevention, in particular the predictive value of modifiable cardiovascular disease risk factors, may warrant exploration. The evidence base is, however, characterised by discordant findings and is modest in size. Accordingly, we examined the association of modifiable cardiovascular disease risk factors with dementia death.
				</AbstractText>
				<AbstractText Label="DESIGN AND METHODS" NlmCategory="METHODS">
					We pooled raw data from 10 UK general population-based prospective cohort studies within the context of an individual participant meta-analysis.
				</AbstractText>
				<AbstractText Label="RESULTS" NlmCategory="RESULTS">
					A total of 103,764 men and women were followed up for a mean of 8 years giving rise to 443 dementia-related deaths and 2612 cardiovascular disease deaths. Cardiovascular disease mortality was, as anticipated, associated with the full range of risk factors under study, including raised blood pressure, smoking, diabetes, physical inactivity. By contrast, dementia death was related to very few of the cardiovascular disease risk factors: of those classified as modifiable, only smoking was associated with a raised risk and higher levels of non-HDL with a lower risk.
				</AbstractText>
				<AbstractText Label="CONCLUSIONS" NlmCategory="CONCLUSIONS">
					In the present individual participant meta-analysis, there was limited evidence that cardiovascular disease risk factors were related to dementia death.
				</AbstractText>
			</Abstract>
		 * 
		 * */
		
		
		public StringBuffer processFetchAbstract(String id)throws Exception{
			StringBuffer rtn = new StringBuffer();//"The attributable risk of developing lower extremity lymphedema was 23% for patients with endometrial cancer who underwent lymphadenectomy compared with hysterectomy alone with an overall prevalence of 47%. Lymphedema was associated with reductions in multiple quality-of-life domains. LEVEL OF EVIDENCE:: II.";
			//http://eutils.ncbi.nlm.nih.gov/entrez/eutils/efetch.fcgi?db=pubmed&retmode=xml&id=19008416
			String fetchUrl = PubmedDataInterface.baseUrl +"efetch.fcgi?db=pubmed&retmode=xml&id=";
			fetchUrl += id;
			CommonMethod.screenPrint("_______________in PubmedDataInterface processFetchAbstract:id:"+id+",fetchUrl:"+fetchUrl);
			String tmpName; 
			
			URL url = new URL(fetchUrl);
		    Document document=this.parse(url);        
		    Element root = document.getRootElement();//PubmedArticleSet
		    
		    String label;
		    
		    Iterator i = root.elementIterator();
		    if(i.hasNext()){
		    	Element PubmedArticle = (Element) i.next();//PubmedArticle
		    	for( Iterator j = PubmedArticle.elementIterator(); j.hasNext(); ){
		    			 Element MedlineCitation = (Element) j.next();
		    			 tmpName = MedlineCitation.getName();
			    		 if(tmpName.equals("MedlineCitation")){
			    			 for( Iterator k = MedlineCitation.elementIterator(); k.hasNext(); ){
			    				 Element Article = (Element) k.next();
			    				 tmpName = Article.getName();
			    				 if(tmpName.equals("Article")){
			    					 for( Iterator l = Article.elementIterator(); l.hasNext(); ){
			    						 Element Abstract = (Element) l.next();
			    						 tmpName = Abstract.getName();
			    						 if(tmpName.equals("Abstract")){
				    						 for( Iterator m = Abstract.elementIterator(); m.hasNext(); ){
				    							 Element AbstractText = (Element) m.next();
				    							 label = AbstractText.attributeValue("Label");
				    							 if(label!=null){
				    								 rtn.append(label+paragraphFlag);
				    								 tmpName = AbstractText.getName();
				    								 if(tmpName.equals("AbstractText")){
				    									 if(AbstractText.getText()!=null){
				    										 rtn.append( AbstractText.getText()+paragraphFlag );
				    									 }else{
				    										 rtn.append( paragraphFlag );
				    									 }
				    								 }
				    							 }else{
				    								 rtn.append( AbstractText.getText()+paragraphFlag );
				    							 }
				    						 
				    						 }
			    						 }
			    					 }
			    				 }
			    			 }
			    		 }
		    			 
		    		 }
		    	 }
		   return rtn;
		}
		//prepare list models
		private ArrayList<Citation> processSummary(String ids)throws Exception{
			System.out.println("param:ids:"+ids);
			ArrayList<Citation> rtn =  new ArrayList();
			String summaryUrl =  PubmedDataInterface.baseUrl+"esummary.fcgi?db="+PubmedDataInterface.db+"&id="+ids;
			System.out.println("summaryUrl:"+summaryUrl);
			URL url = new URL(summaryUrl);
		    Document document=this.parse(url);        
		    Element root = document.getRootElement();
		    
		    
		    for ( Iterator i = root.elementIterator(); i.hasNext(); ) 
		    {
		    		Citation aPaper = new Citation();
		    		aPaper.setResType(this.resType);
		    		//-----------read xml-----------
		    		Element row = (Element) i.next();
		            Iterator itr = row.elementIterator();
		            String tmpTag = "";
		            String tmpValue = "";
		            Element tmpDocSum ;
		            String tmpAuthor;
		            while(itr.hasNext())
	                {
		            	tmpDocSum = (Element) itr.next();
		            	tmpTag = tmpDocSum.getName();
		            	tmpValue = tmpDocSum.getText();
		            	//screenPrint("----------------tmpTag:"+tmpTag+",tmpValue:"+tmpValue);
		            	if(tmpTag.equals("Id")){
		            		aPaper.setResId(tmpValue);
		            	}else if(tmpTag.equals("Item")){
		            		String itemName = tmpDocSum.attributeValue("Name");
		            		//screenPrint("itemName:"+itemName);
		            		if(itemName.equals("Title")){
			            		aPaper.setTitle(tmpValue);
			            	}else if(itemName.equals("PubDate")){
			            		aPaper.setYear(tmpValue);
			            	}else if(itemName.equals("Source")){
			            		aPaper.setSource(tmpValue);
			            	}else if(itemName.equals("AuthorList")){
			            		Iterator auths = tmpDocSum.elementIterator();
			            		Element aAuth;
			            		tmpAuthor="";
			            		while(auths.hasNext()){
			            			aAuth = (Element) auths.next();
			            			tmpAuthor += aAuth.getText()+",";
			            		}
			            		if(tmpAuthor.endsWith(",")){
			            			tmpAuthor = tmpAuthor.substring(0,tmpAuthor.length()-1);
			            		}
			            		aPaper.setAuthor(tmpAuthor);
			            	}
		            	}
	               }
		            //System.out.println("_______________aPaper:"+aPaper.toString());
		            rtn.add(aPaper);
		    }//end of for
		    return rtn;

		   }
		    
		
		public Document parse(URL url) throws DocumentException 
		    {
				CommonMethod.screenPrint(url.toString());
				SAXReader reader = new SAXReader();
		        Document document = reader.read(url);
		        
		        return document;
		    }
	    public static ArrayList<Citation> getPubmedCitations(){
	    	ArrayList<Citation> rtn = new ArrayList();
	    	return rtn;
	    }
	    
	    
	    public class SearchModel{
	    	public int count;
	    	public int retMax;
	    	public int retStart;
	    	public int queryKey;
	    	public String webEnv;
	    	public String ids="";
	    	public ArrayList<String> idList;
	    	public String toString(){
	    		String rtn = "";
	    		rtn = "count="+count+",retMax="+retMax+",retStart="+retStart+",queryKey="+queryKey+",webEnv="+webEnv+",idList=";
	    		for(int i=0;i<idList.size();i++){
	    			String tmp = (String)idList.get(i);
	    			rtn+=tmp+",";
	    		}
	    		//System.out.println("in searchModel:"+rtn);
	    		return rtn;
	    	}
	    	/*<Count>96</Count>
	    	<RetMax>20</RetMax>
	    	<RetStart>0</RetStart>
	    	<QueryKey>1</QueryKey>
	    	<WebEnv>
	    	NCID_1_357814788_130.14.18.34_9001_1401626619_1313332610
	    	</WebEnv>
	    	<IdList>*/
	    }
		public static void main(String args[]){
			//String term = "science[journal]+AND+cancer+AND+2008[pdat]";
			//String keyWords = "science[journal] cancer 2008";
			String keyWords = "Modifiable cardiovascular disease risk factors as predictors of dementia death: pooling of ten general population-based cohort studies";
			String searchUrl = PubmedDataInterface.baseUrl +"esearch.fcgi?db=pubmed&usehistory=y&term="+keyWords;
			
			try {
				//PubmedDataInterface pubmed = new PubmedDataInterface(searchUrl,term);
				//pubmed.processSearch();
				PubmedDataInterface pubmed = new PubmedDataInterface();
				//ArrayList<Citation> result = pubmed.processSearch(keyWords);
				//System.out.println("search result:"+result.size());
				
				String abstractStr = (pubmed.processFetchAbstract("24886432")).toString();//19008416
				CommonMethod.screenPrint("abstract:"+abstractStr);
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
		}

		

	}


