package servlets;

import gate.Corpus;
import gate.Factory;
import gate.GateExtractor;
import gate.GateExtractor.EnumMode;
import gate.GateExtractor.EnumProject;
import gate.GateInstance;
import gate.PipelineFactory;
import gate.creole.ResourceInstantiationException;
import gate.jape.JapeKeywords;
import gate.jape.JapeMain;
import gate.pattern.CarreRule;
import gate.pattern.HotmapRule;
import gate.util.CommonMethod;
import gate.util.GateException;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import model.Citation;
import resource.api.PubmedDataInterface;

import com.fasterxml.jackson.databind.ObjectMapper;

public class GateAnalysis extends HttpServlet{
	private String resId;//paperId in pubmed
	private String analysisKeywords;
	private String dics;
	private String strProject;
	
    public void doGet(HttpServletRequest request, HttpServletResponse response)
    throws IOException, ServletException
    {
    	
    	
    	resId = (String)request.getParameter("resId").trim();
    	analysisKeywords = (String)request.getParameter("analysisKeywords").trim();
    	
    	dics = (String)request.getParameter("dics").trim();
    	strProject = (String)request.getParameter("project").trim();
    	EnumProject project = EnumProject.valueOf(strProject);
    	
    	
    	response.setContentType("text/html");
        PrintWriter output = response.getWriter();
        
        
        
        
        CommonMethod.screenPrint("parameters from keywords window page, resId:"+resId+",analysisKeywords:"+analysisKeywords);
        String uuid = CommonMethod.UuidGenerator();
    	//create original file as url
        boolean flag = GateExtractor.createTaggedFile("null", resId,uuid);
        String sUrl = null;
        if(flag){
        	sUrl = GateExtractor.getTmpFileURL(uuid);
        }
        
        JapeMain obj = new JapeMain(analysisKeywords,"userName","nodeName");//(analysisKeywords,userName,nodeName);
		String mainFileName = obj.createMainFile();//get main file formatted name
		
		try {
			EnumMode mode = EnumMode.web;
			CommonMethod.screenPrint("in GateExtractor step1 mode:"+mode);
			GateInstance.getInstance();
			CommonMethod.screenPrint("in GateExtractor step2 GateInstance");
			//------read pattern file first
			CarreRule.getInstance();
			HotmapRule.getInstance();
			
			CommonMethod.screenPrint("in GateExtractor step3 rule getInstance");
			//------read property file next
			//----------init PR 
			PipelineFactory.initProcessingResouces(mode);
			CommonMethod.screenPrint("in GateExtractor step4 initProcessingResouces");
			//----------------
			GateExtractor extObj = new GateExtractor( mainFileName,analysisKeywords,mode);//0 for stand alone
			//extObj.setTestFile(testFile);
			extObj.initSerialAnnieNew(dics);
			CommonMethod.screenPrint("in GateExtractor step5 initSerialAnnieNew");
			Corpus corpus = Factory.newCorpus("GateParser corpus");
			//corpus.clear();
			//-------create a file----------
			//createFile(corpus,null,null);//add file in corpus
			flag = extObj.createCorpusDocument(corpus,null, resId,uuid) ;//dbType temp null
			// tell the pipeline about the corpus and run it
			if(flag){
				extObj.setCorpus(corpus);
				extObj.execute();
				
				String rAbspath = extObj.processDoc(corpus,project,0);//0 useless
				CommonMethod.screenPrint("\n ...............rAbspath:"+rAbspath);
				File tmpFile = new File(rAbspath);
				BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(tmpFile)));
				String rtnStr ="";
				String line = null;
				int i=0;
				while ((line = br.readLine()) != null) {
					//CommonMethod.screenPrint("line:"+i);
		    	  rtnStr = rtnStr.concat(line);
		    	  i++;
				}
		        //output result file content with tags
				//CommonMethod.screenPrint("\n ...............resultFile from GateAnalysis servlet:"+rtnStr);
				String resultFileURL = CommonMethod.getResultFilePathURLByUuid(uuid);
				CommonMethod.screenPrint("uuid:"+uuid+",link:"+resultFileURL);
				output.print(resultFileURL);
				
			}
		} catch (ResourceInstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (GateException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}catch(Exception e){
			e.printStackTrace();
			CommonMethod.screenPrint("Exception from GateExtractor in main4:"+e.getMessage());
		}
    	
    	/*resId = (String)request.getParameter("resId").trim();
    	analysisKeywords = (String)request.getParameter("analysisKeywords").trim();
    	
    	dics = (String)request.getParameter("dics").trim();
    	project = (String)request.getParameter("project").trim();
    	
    	
    	
    	response.setContentType("text/html");
        PrintWriter output = response.getWriter();
        
        
        
        
        CommonMethod.screenPrint("parameters from keywords window page, resId:"+resId+",analysisKeywords:"+analysisKeywords);
        String uuid = CommonMethod.UuidGenerator();
    	//create original file as url
        boolean flag = GateExtractor.createTaggedFile("null", resId,uuid);
        String sUrl = null;
        if(flag){
        	sUrl = GateExtractor.getTmpFileURL(uuid);
        }
        
        JapeMain obj = new JapeMain(analysisKeywords,"userName","nodeName");//(analysisKeywords,userName,nodeName);
		String mainFileName = obj.createMainFile();//get main file formatted name
		
		try {
			
			GateInstance.getInstance();
			
			CommonMethod.screenPrint("after GateInstance...before initSerialAnnie");
			
			GateExtractor extObj = new GateExtractor( mainFileName,analysisKeywords,EnumMode.web);//0 for stand alone 1 for web
			//extObj.initSerialAnnie(1);//web
			extObj.initSerialAnnieNew(dics);
			Corpus corpus = Factory.newCorpus("GateParser corpus");
			//corpus.clear();
			//-------create a file----------
			//createFile(corpus,null,null);//add file in corpus
			flag = extObj.createCorpusDocument(corpus,null, resId,uuid) ;//dbType temp null
			// tell the pipeline about the corpus and run it
			if(flag){
				extObj.setCorpus(corpus);
				extObj.execute();
				String rAbspath = extObj.processDoc(corpus,EnumProject.valueOf(project),0);//0 useless
				
				CommonMethod.screenPrint("\n ...............rAbspath:"+rAbspath);
				File tmpFile = new File(rAbspath);
				BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(tmpFile)));
				String rtnStr ="";
				String line = null;
				int i=0;
				while ((line = br.readLine()) != null) {
					//CommonMethod.screenPrint("line:"+i);
		    	  rtnStr = rtnStr.concat(line);
		    	  i++;
				}
		        //output result file content with tags
				//CommonMethod.screenPrint("\n ...............resultFile from GateAnalysis servlet:"+rtnStr);
				String resultFileURL = CommonMethod.getResultFilePathURLByUuid(uuid);
				CommonMethod.screenPrint("uuid:"+uuid+",link:"+resultFileURL);
				output.print(resultFileURL);
				
			}
		} catch (ResourceInstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (GateException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}catch(Exception e){
			CommonMethod.screenPrint(e.getMessage());
		}*/
		
    }
}