package servlets;

import java.io.File;
import java.io.IOException;

import gate.Gate;
import gate.util.CommonMethod;

import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class GateInitServlet extends HttpServlet{
	private static boolean gateInited = false;
	private String pluginsHome;
	public void init()throws ServletException{
		if(!gateInited){
			try{
				ServletContext ctx = getServletContext();
				//use /path/to/yor/webapp/WEB-INF as gate.home
				File gateHome = new File(ctx.getRealPath("/WEB-INF"));
				Gate.setGateHome(gateHome);
				//thus webapp/WEB-INF/plugins is the plugins directory, and //web/WEB-INF/gate.xml is the site config file.
				//use webapp/WEB-INF/user-gate.xml as the user config file to avoid confusion with your own user config.
				Gate.setUserConfigFile(new File(gateHome,"user-gate.xml"));
				Gate.init();
				//load plugins.for example..
				pluginsHome = "/WEB-INF/plugins/";
				CommonMethod.screenPrint("resources:"+ctx.getResource(pluginsHome+"ANNIE").toString());
				Gate.getCreoleRegister().registerDirectories(ctx.getResource(pluginsHome+"ANNIE"));
				Gate.getCreoleRegister().registerDirectories(ctx.getResource(pluginsHome+"Gazetteer_Ontology_Based"));
				Gate.getCreoleRegister().registerDirectories(ctx.getResource(pluginsHome+"Ontology"));
				Gate.getCreoleRegister().registerDirectories(ctx.getResource(pluginsHome+"Tools"));
				Gate.getCreoleRegister().registerDirectories(ctx.getResource(pluginsHome+"Ontology_Tools"));
				gateInited = true;
				System.out.println(">>>>>>>>>>>>Gate inited............");
			}catch(Exception ex){
				ex.printStackTrace();
				throw new ServletException("Exception initializing Gate",ex);
			}
		}
	}
/*	 public void doGet(HttpServletRequest request, HttpServletResponse response)
			    throws IOException, ServletException
			    {
		 			init();
		 			System.out.println(">>>>>>>>>>>>Gate inited............");
			    }
*/
}
