package util;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.LinkedHashMap;
import java.util.List;

import model.TrainingExcelModel;
import model.TrainingModel;
import model.db.TrainingPaperModel;
import model.db.TrainingPhraseModel;
import model.db.TrainingSentenceModel;

import org.lightcouch.Attachment;
import org.lightcouch.CouchDbClient;
import org.lightcouch.Response;
import org.lightcouch.View;

import gate.ComparatorHtmlTag;
import gate.ComparatorInt;
import gate.ComparatorPhrase;
import gate.HtmlModel;
import gate.util.CommonMethod;
import clearnlp.TagModel;

import com.google.gson.JsonArray;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;

import org.lightcouch.Params;
import org.apache.commons.codec.binary.Base64;
import org.apache.commons.codec.binary.StringUtils;

public class DBAccess {

	public static String dbCfgStr = "db.properties";
	private CouchDbClient dbClient;
	private String outFileName = "D:\\work\\Gate\\test\\view_predictcorecomponent.txt";
	
	public DBAccess(){
		//dbCfgStr = CommonMethod.getDBProperties();
		dbClient = new CouchDbClient(dbCfgStr);
		
	}
	public String getDbCfgStr(){
		return this.dbCfgStr;
	}
	public static void main(String args[]){
		main3();
	}
	public CouchDbClient getDbClient(){
		return dbClient;
	}
	public static void main0(){
		testSaveAttachment();
	}
	public static void main1(){
		DBAccess aDB = new  DBAccess();
		Hashtable<String,TrainingExcelModel> rtn = aDB.readPaperAttachment("paper/paperAttachmentWithTitle");//("paper/paperAttachment");
		
	}
	//____be careful_________!!!!
	public static void main2(){
		DBAccess aDB = new  DBAccess();
		//aDB.removeAllDocModel();
		aDB.removeAllPhraseModel();
	}
	
	public static void main3(){
		DBAccess aDB = new  DBAccess();
		//aDB.removeAllDocModel();
		aDB.readPredictCoreComponentAggregate();
	}
	
	public static String getSubStringFromDBURI(String uri){
		CouchDbClient dbClient = new CouchDbClient(new DBAccess().getDbCfgStr());
		String dbUri = dbClient.getDBUri().toString();
		String rtn = uri.substring(dbUri.length());
		return rtn;
	}
	//http://10.1.62.239:5984/db-test2/_design/paper/_view/trainingPhrase?startkey=[%22achieve%22,%22goal%22,%22OBJ%22]&endkey=[%22achieve%22,%22goal%22,%22OBJ%22]
	public  ArrayList<String> readRelatedDocFromPhrase(String startKey,String endKey,StringBuffer sb){
		ArrayList<String> rtn = new ArrayList<String>();
		CouchDbClient dbClient  = getDbClient();
		String viewName = "paper/trainingPhrase";
		View VACgrp =  dbClient.view(viewName).startKey(startKey).endKey(endKey).includeDocs(true);
		//ArrayList<JsonObject> attList;
		ArrayList<TrainingSentenceModel> attList;
		attList = (ArrayList)VACgrp.query(TrainingSentenceModel.class);
		if(attList!=null){
			CommonMethod.screenPrint("------------------sentence start:"+startKey+",endkey:"+endKey+"----------------------------");
			for(int i=0;i<attList.size();i++){
				TrainingSentenceModel aSentence = (TrainingSentenceModel)attList.get(i);
				sb.append("{"+aSentence.toString()+"}\n");
				rtn.add(aSentence.getPid()+"@"+aSentence.getId());//pid@sid
			}
		}
		return rtn;
	}
	//http://10.1.62.239:5984/db-test2/_design/paper/_view/view_predictcorecomponent?group=true
	public LinkedHashMap<String, ArrayList> readPredictCoreComponentAggregate(){
		LinkedHashMap<String, ArrayList> lhm = new LinkedHashMap<String, ArrayList>();
		
		CouchDbClient dbClient  = getDbClient();
		String viewName = "paper/view_predictcorecomponent";
		View VACgrp =  dbClient.view(viewName).group(true);
		ArrayList<JsonObject> attList;
		attList = (ArrayList)VACgrp.query(JsonObject.class);
		JsonArray keyArr;
		int value;
		ArrayList<String> psId = null;
		ArrayList<TrainingPhraseModel> phraseList;
		TrainingPhraseModel aModel;
		if(attList!=null){
			JsonObject aVAC;
			phraseList = new ArrayList();
			String startKey,endKey;
			for(int i=0;i<attList.size();i++){
				aVAC = (JsonObject)attList.get(i);
				keyArr = aVAC.get("key").getAsJsonArray();
				value = aVAC.get("value").getAsInt();
				
				aModel = new TrainingPhraseModel("null");
				aModel.setPredict(keyArr.get(0).toString());
				aModel.setCore(keyArr.get(1).toString());
				aModel.setComponent(keyArr.get(2).toString());
				aModel.setValue(value);
				
				//CommonMethod.screenPrint("key:"+keyArr.toString()+",value:"+value);
				if(aModel.getValue()>=2 && (!aModel.getPredict().equals("\"\"") && !aModel.getComponent().equals("\"\"") && !aModel.getCore().equals("\"\"")))
				{
					//CommonMethod.screenPrint("core:equals:"+aModel.getCore().equals("\"\"")+",equals:"+aModel.getCore().equals(""));
					//CommonMethod.screenPrint("length:"+aModel.getCore().length()+",core:"+aModel.getCore()+",aModel:"+aModel.toString());
					//startKey = "[\""+aModel.getPredict()+"\",\""+aModel.getCore()+"\",\""+aModel.getComponent()+"\"]";
					
					phraseList.add(aModel);
				}
			}
			//----------sort
			ComparatorInt comparator=new ComparatorInt();
			Collections.sort(phraseList, comparator);
			
			
			//--------------output----------------
			StringBuffer sb = new StringBuffer();
			for(int i=0;i<phraseList.size();i++){
				//CommonMethod.screenPrint(((TrainingPhraseModel)phraseList.get(i)).toString());
				TrainingPhraseModel aPhrase = ((TrainingPhraseModel)phraseList.get(i));
				sb.append("-----------"+aPhrase.toString()+"-------------\n");
				//------------sentence------------
				startKey = aPhrase.getPredict()+"_"+aPhrase.getCore()+"_"+aPhrase.getComponent();
				if(startKey.contains("\"")){
					startKey = startKey.replace("\"", "");
				}
				endKey = startKey;
				psId = readRelatedDocFromPhrase(startKey,endKey,sb);
				lhm.put(startKey, psId);
				
			}
			
			Writer writer = null;

	        try {
	            File file = new File(outFileName);
	            BufferedWriter output = new BufferedWriter(new FileWriter(file));
	            output.write(sb.toString());
	            output.close();
	          } catch ( IOException e ) {
	             e.printStackTrace();
	          }
		}
		CommonMethod.screenPrint("in DBAccess readPredictCoreComponentAggregate over");
		return lhm;
	}
	//--------------------
	//http://10.1.62.239:5984/db-test2/_design/paper/_view/view_predictcorecomponent?group=true
	//http://10.1.62.239:5984/db-test2/_design/paper/_view/view_predictcorecomponent?group=true&startkey=[%22achieve%22,%22datum%22,%22OBJ%22]&endkey=[%22achieve%22,%22datum%22,%22OBJ%22]
	//http://10.1.62.239:5984/db-test2/_design/paper/_view/trainingPhrase?include_docs=true
	
	//get reduced result 
	//--------------------
	//"paper/paperAttachment"
	/*
	 * {"total_rows":60,"offset":0,"rows":[
			{"id":"00a4456d_67a9_48bb_b3c2_26a037ebabb2","key":["cloth"," A Consistent Bending Model for Cloth Simulation with\nCorotational Subdivision Finite Elements\n"],"value":["Reference.txt","Abstract.txt","RelatedWork.txt"]},
			{"id":"88803500_88e7_4354_8680_362c9e82c697","key":["cloth"," A Consistent Bending Model for Cloth Simulation with\nCorotational Subdivision Finite Elements\n"],"value":["Reference.txt","Abstract.txt","RelatedWork.txt"]},
			{"id":"b8955a93_e551_415c_9350_f15889bd0424","key":["cloth"," A Consistent Bending Model for Cloth Simulation with\nCorotational Subdivision Finite Elements\n"],"value":["Reference.txt","Abstract.txt","RelatedWork.txt"]}
		]}
	 * */
	//hashKey = sId+"-"+paperPortion;
	public Hashtable<String,TrainingExcelModel> readPaperAttachment(String designDocWithView){
		Hashtable<String,TrainingExcelModel> rtn = null;//urlList;
		ArrayList<JsonObject> attList;
		//http://10.1.62.239:5984/db-test/_design/paper/_view/paperAttachment
		CouchDbClient dbClient = new CouchDbClient(dbCfgStr);
		String dbUriBase = dbClient.getBaseUri().toString();
		String dbUri = dbClient.getDBUri().toString();
		View paperAttachments = dbClient.view(designDocWithView);
		attList = (ArrayList)paperAttachments.query(JsonObject.class);
		String urlTmp,sId,sFileName;
		if(attList!=null){
			JsonObject aPaperPartDoc;
			rtn = new Hashtable<String,TrainingExcelModel>();
			TrainingExcelModel teModel;
			JsonArray keyArr,valueArr;
			String hashKey,paperPortion;
			for(int i=0;i<attList.size();i++){
				aPaperPartDoc = (JsonObject)attList.get(i);
				sId = (String)aPaperPartDoc.get("id").getAsString();
				valueArr = aPaperPartDoc.get("value").getAsJsonArray();
				keyArr = aPaperPartDoc.get("key").getAsJsonArray();
				
				
				int modelSize = valueArr.size();
				for(int j=0;j<modelSize;j++){
					teModel = new TrainingExcelModel();
					sFileName =valueArr.get(j).toString().replace("\"", "");
					paperPortion = sFileName.substring(0,sFileName.indexOf("."));
					
					urlTmp = dbUri+sId+"/"+sFileName;
					teModel.setPid(sId);//pId,url,folderName,title
					teModel.setUrl(urlTmp);
					teModel.setFolderName(keyArr.get(0).getAsString());
					teModel.setTitle(keyArr.get(1).getAsString());
					
					teModel.setPaperPortion(paperPortion);//"abstract.txt"->"abstract"
					hashKey = sId+"-"+paperPortion;
					rtn.put(hashKey,teModel);
					CommonMethod.screenPrint(urlTmp);
				}
			}
		}
		return rtn;
	}

	public ArrayList<TrainingPhraseModel> readPhraseSentenceCombiDoc(){
		ArrayList<TrainingPhraseModel> rtn = new ArrayList<TrainingPhraseModel>();
		ArrayList<TrainingPhraseModel> tmpList;
		CouchDBClientImpl impl = new CouchDBClientImpl();
		ArrayList<TrainingSentenceModel> sDocs =  readSentenceDoc();
		String sId ;
		String viewName = "paper/phraseModelOfSentenceView";
		if(sDocs!=null){
			TrainingSentenceModel asModel;
			for(int i=0;i<sDocs.size();i++){//loop each sentence
				asModel = (TrainingSentenceModel)sDocs.get(i);
				//-----------
				//http://10.1.62.239:5984/db-test2/_design/paper/_view/phraseModelOfSentenceView?key="0017abda_00c4_4436_8d7f_ce183f9cabc3"
				sId = asModel.getId();
				View phraseOfSentenceView =  dbClient.view(viewName).includeDocs(true).key(sId);
				tmpList = (ArrayList<TrainingPhraseModel>)phraseOfSentenceView.query(TrainingPhraseModel.class);
				//-----sort it
				//----------sort
				ComparatorPhrase comparator=new ComparatorPhrase();
				Collections.sort(tmpList, comparator);
				//------------output
				TrainingPhraseModel sModel = new TrainingPhraseModel("");
				sModel.setId(asModel.getSentContent());
				rtn.add(sModel);//sentence Content
				rtn.addAll(tmpList);// phraseList
			}
		}
		return rtn;
	}
	public ArrayList<TrainingPhraseModel> readPhraseDoc(){
		ArrayList<TrainingPhraseModel> rtn;
		CouchDBClientImpl impl = new CouchDBClientImpl();
		String viewName = "paper/phraseModelView";
		View sentenceView =  dbClient.view(viewName).includeDocs(true);//.startKey(startKey).endKey(endKey).includeDocs(true);
		//ArrayList<JsonObject> attList;
		rtn = (ArrayList<TrainingPhraseModel>)sentenceView.query(TrainingPhraseModel.class);
		CommonMethod.screenPrint(((TrainingPhraseModel)rtn.get(0)).toString());
		
		return rtn;
	}
	
	public ArrayList<TrainingSentenceModel> readSentenceDoc(){
		ArrayList<TrainingSentenceModel> rtn;
		CouchDBClientImpl impl = new CouchDBClientImpl();
		String viewName = "paper/sentenceModelView";
		View sentenceView =  dbClient.view(viewName).includeDocs(true);//.startKey(startKey).endKey(endKey).includeDocs(true);
		//ArrayList<JsonObject> attList;
		rtn = (ArrayList<TrainingSentenceModel>)sentenceView.query(TrainingSentenceModel.class);
		CommonMethod.screenPrint(((TrainingSentenceModel)rtn.get(0)).toString());
		
		return rtn;
	}
	public ArrayList<TrainingPaperModel> readPaperDoc(){
		ArrayList<TrainingPaperModel> rtn;
		CouchDBClientImpl impl = new CouchDBClientImpl();
		String viewName = "paper/paperModelView";
		View paperView =  dbClient.view(viewName).includeDocs(true);//.startKey(startKey).endKey(endKey).includeDocs(true);
		//ArrayList<JsonObject> attList;
		rtn = (ArrayList<TrainingPaperModel>)paperView.query(TrainingPaperModel.class);
		CommonMethod.screenPrint(((TrainingPaperModel)rtn.get(0)).toString());
		
		return rtn;
	}
	public String saveTrainingPhrase(TrainingPhraseModel tpModel){
		CouchDBClientImpl impl = new CouchDBClientImpl();
		Response response = impl.save(tpModel);
		return response.getId();
	}
	//save a model in db
	//export :paperId	forder	title
    //save
	public boolean saveTrainingModel(TrainingModel tModel,Hashtable aPaperTable){
		CouchDbClient dbClient = new CouchDbClient(dbCfgStr);
		CommonMethod.screenPrint("pId0:"+tModel.getId());
		tModel.setId(tModel.getPid());
		Response response = dbClient.save(tModel); //save
		//String id = tModel.getId();

		tModel = dbClient.find(TrainingModel.class,  response.getId());
		CommonMethod.screenPrint("response id1:"+ response.getId());
		//save attachment
		if(aPaperTable!=null){
			Enumeration<String> enumKey = aPaperTable.keys();
			while(enumKey.hasMoreElements()) {
			    String portion = enumKey.nextElement();
			    String content = "<"+portion+">"+ (String)aPaperTable.get(portion)+"</"+portion+">";
			    byte[] bytes = content.getBytes(); 
			    String data = Base64.encodeBase64String(bytes);
			    Attachment attachment = new Attachment(data,"text/html");//(data, "text/plain");	
			    //Bar bar = new Bar(); 
			    tModel.addAttachment(portion+".html", attachment);
			    CommonMethod.screenPrint("pId2:"+response.getId());
			}
			 response = dbClient.update(tModel); //update
		}
		return true;
	}
	
	
	public String saveSentenceModel(TrainingExcelModel docModel, TagModel tagModel){
		String rtn = "";
		CouchDbClient dbClient  = getDbClient();
		
		String sentenceId =  CommonMethod.UuidGenerator();
		TrainingSentenceModel tsModel = new TrainingSentenceModel(sentenceId);
		tsModel.setPid(docModel.getPid());
		tsModel.setPapPortion(docModel.getPaperPortion());
		tsModel.setStartId(tagModel.getStart());//sentence index
		tsModel.setEndId(tagModel.getEnd());
		tsModel.setSenContent(tagModel.getContent());
		tsModel.setTagName(tagModel.getTagName());
		//----------------save-----------
		Response response = dbClient.save(tsModel); //save
		tsModel = dbClient.find(TrainingSentenceModel.class,  response.getId());
		rtn = sentenceId;
		return rtn;
	}
	
	public boolean removeAllDocModel(){
		String designView = "paper/paperAttachmentWithTitle";//"paper/paperAttachment";
		ArrayList<JsonObject> attList;
		Response response;
		boolean rtn = false;
		
		String dbUri = dbClient.getDBUri().toString();
		View paperAttachments = dbClient.view(designView);
		attList = (ArrayList)paperAttachments.query(JsonObject.class);
		String urlTmp,sId,sFileName;
		if(attList!=null){
			JsonObject aPaperPartDoc;
			TrainingModel tModel;
			JsonArray keyArr,valueArr;
			String hashKey,paperPortion;
			for(int i=0;i<attList.size();i++){
				aPaperPartDoc = (JsonObject)attList.get(i);
				sId = (String)aPaperPartDoc.get("id").getAsString();
				tModel = dbClient.find(TrainingModel.class,sId);
				response = dbClient.remove(tModel); 
			}

		}
		rtn = true;
		return rtn;
	}
	//remove all Training Phrase Model before do another insert
	public boolean removeAllPhraseModel(){
		String designView = "paper/trainingPhrase";//"paper/paperAttachment";
		ArrayList<JsonObject> attList;
		Response response;
		boolean rtn = false;
		
		String dbUri = dbClient.getDBUri().toString();
		View paperAttachments = dbClient.view(designView);
		attList = (ArrayList)paperAttachments.query(JsonObject.class);
		String urlTmp,sId,sFileName;
		if(attList!=null){
			JsonObject aPaperPartDoc;
			TrainingModel tModel;
			JsonArray keyArr,valueArr;
			String hashKey,paperPortion;
			for(int i=0;i<attList.size();i++){
				aPaperPartDoc = (JsonObject)attList.get(i);
				sId = (String)aPaperPartDoc.get("id").getAsString();
				tModel = dbClient.find(TrainingModel.class,sId);
				response = dbClient.remove(tModel); 
			}

		}
		rtn = true;
		return rtn;
	}
	//remove all Training Phrase Model before do another insert
	public boolean removeAllSentenceModel(){
		String designView = "paper/sentenceModel";//"paper/paperAttachment";
		ArrayList<JsonObject> attList;
		Response response;
		boolean rtn = false;
		
		String dbUri = dbClient.getDBUri().toString();
		View paperAttachments = dbClient.view(designView);
		attList = (ArrayList)paperAttachments.query(JsonObject.class);
		String urlTmp,sId,sFileName;
		if(attList!=null){
			JsonObject jObj;
			TrainingSentenceModel tModel;
			JsonArray keyArr,valueArr;
			String hashKey,paperPortion;
			for(int i=0;i<attList.size();i++){
				jObj = (JsonObject)attList.get(i);
				sId = (String)jObj.get("id").getAsString();
				tModel = dbClient.find(TrainingSentenceModel.class,sId);
				response = dbClient.remove(tModel); 
			}

		}
		rtn = true;
		return rtn;
	}
	
	
	private static void testSaveAttachment() {
		String dbCfgStr = "db.properties";
		CouchDbClient dbClient = new CouchDbClient(dbCfgStr);
		String docId =  CommonMethod.UuidGenerator();
		TrainingModel tModel = new TrainingModel(docId);
		String id = tModel.getId();
		CommonMethod.screenPrint("id:"+id);
		//JsonObject testObj = new  JsonObject();
		Response response = dbClient.save(tModel); //save
	
		tModel.setPid("paperId");
		tModel.setTypeName("cloth");
		tModel.setSentenceId("sentenceid");
		tModel.setTitle("paper title");
		
		tModel = dbClient.find(TrainingModel.class,  response.getId());
		
		CommonMethod.screenPrint("response id:"+ response.getId());
		
		byte[] bytes = "binary string".getBytes(); 
		String data = Base64.encodeBase64String(bytes);
		Attachment attachment = new Attachment(data, "text/plain");	
		//Bar bar = new Bar(); 
		tModel.addAttachment("bar.txt", attachment);
		 
		response = dbClient.update(tModel); //update
		CommonMethod.screenPrint("response id:"+ response.getId());
		
		tModel = dbClient.find(TrainingModel.class, response.getId(), new Params().attachments());
		String base64Data = tModel.getAttachments().get("bar.txt").getData();
		//String base64Data = tModel.getAttachments().get("bar.txt").getData();
		CommonMethod.screenPrint("output from base64data:"+ decode(base64Data));//need a decode
	}
	public static String decode(String s) {
	    return StringUtils.newStringUtf8(Base64.decodeBase64(s));
	}
	public static String encode(String s) {
	    return Base64.encodeBase64String(StringUtils.getBytesUtf8(s));
	}
	 /*
	  * 
	  * function(doc) {
			if(doc.pId!=null){
				var fNames =[];
		                var i=0;
		
		                 for(fName in  doc._attachments){
		                   fNames[i]=fName;
		                   i++;
		                  }
		  		emit([doc.typeName,doc.title], fNames);
			}
		}
	  * */
	
	
}
