package util;

import org.apache.xerces.parsers.DOMParser;
import org.w3c.dom.Document;
import org.w3c.dom.DocumentType;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

import gate.util.CommonMethod;

import java.io.File;
import java.io.IOException;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;



public class PaperXmlParser {
	
	private Document dom;
	private String Title;
	private String fileName ;
	private StringBuffer Abstract;
	private StringBuffer RelatedWork;
	private StringBuffer Reference;
	private  enum tagEnum {Title, Abstract,RelatedWork,Reference};
	private String tagName = "";
	private Hashtable pTable;
	//private String   
	
	
	public PaperXmlParser(String fileName){
		this.fileName = fileName; 
	}
	//segment xml file into parts saved in the DB
	
	public void processDocument(){
		 pTable=null;
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance(); 
		File file = new File(this.fileName);    
		try {
			 DocumentBuilder db = dbf.newDocumentBuilder();  
			 Document doc = db.parse(file);
			 NodeList nl = doc.getElementsByTagName("Tag"); 
			 int len = nl.getLength(); 
			 String nValue ;
			 String nName;
			 if(len>0){
				  pTable = new Hashtable();
				  for (int i = 0; i < len; i++) { 
		                Element elTag = (Element) nl.item(i); 
		                nName = elTag.getAttributeNode("name").getNodeValue();
		                nValue = elTag.getTextContent(); 
		                pTable.put(nName, nValue);
				  }
			 }
		} catch (  IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ParserConfigurationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SAXException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
		
	}
	
	public static void main3(){
		   //String xmlFile = "D:\\work\\Gate\\trainingModel\\trainingTest2.xml";
		//String xmlFile = "D:\\work\\Gate\\trainingModel\\fromDina\\Cloth10.xml";
		String xmlFile = "D:\\work\\Gate\\trainingModel\\fromDina\\ClothFinal\\Cloth2.xml";
		   try {
		    	PaperXmlParser bd = new PaperXmlParser(xmlFile);
		    	bd.processDocument();
		    	CommonMethod.screenPrint(bd.toString());
		   } catch (Exception e) {
			      e.printStackTrace();
			      System.out.println("Error: " + e.getMessage());
		  }
	}
	public Hashtable getPaperTable(){
		return this.pTable;
	}
	 public String toString(){
		String rtn = "\n";
		 if(pTable!=null){
			 Iterator itr = pTable.keySet().iterator();
			 while(itr.hasNext()) {
			     String key = (String)itr.next();
			     String value = (String)pTable.get(key);
			     rtn+=key+":"+value+"\n";
			 }
		}
		 return rtn;
	 }

	   // Main Method
	   public static void main (String[] args) {
		   main3();
		   char a = '';
	   }

		
		/*DOMParser parser = new DOMParser();

	      //  Parse the Document     
	      //  and traverse the DOM
	      try {
	         parser.parse(fileName);
	         dom = parser.getDocument();
	         //traverse (dom);
	      } catch (SAXException e) {
	         System.err.println (e);
	      } catch (IOException e) {
	         System.err.println (e);
	      }
	      
	      		
		 * I take a xml element and the tag name, look for the tag and get
		 * the text content
		 * i.e for <employee><name>John</name></employee> xml snippet if
		 * the Element points to employee node and tagName is 'name' I will return John
		 
	      
	      		//not working
		private String getTextValue(Element ele, String tagName) {
			String textVal = null;
			NodeList nl = ele.getElementsByTagName(tagName);
			if(nl != null && nl.getLength() > 0) {
				Element el = (Element)nl.item(0);
				textVal = el.getFirstChild().getNodeValue();
			}
			return textVal;
		}
		// Traverse DOM Tree.  Print out Element Names
		//not working
		private void traverse (Node node) {
		      int type = node.getNodeType();
		      if (type == Node.ELEMENT_NODE)
		         System.out.println (node.getNodeName());
		      NodeList children = node.getChildNodes();
		      if (children != null) {
		         for (int i=0; i< children.getLength(); i++) 
		            traverse (children.item(i));  
		      }
		   }
		   
		   
		   	  public void processNode(Node node, String spacer) throws IOException {
		    if (node == null)
		      return;
		    switch (node.getNodeType()) {
		    
		    case Node.ELEMENT_NODE:
		      String name = node.getNodeName();
		      System.out.print("ELEMENT_NODE:"+spacer + "<" + name);
		      NamedNodeMap nnm = node.getAttributes();
		      for (int i = 0; i < nnm.getLength(); i++) {
		        Node current = nnm.item(i);
		        System.out.print(" " + current.getNodeName() + "= " + current.getNodeValue());
		      }
		      System.out.print(">");
		      NodeList nl = node.getChildNodes();
		      if (nl != null) {
		        for (int i = 0; i < nl.getLength(); i++) {
		          processNode(nl.item(i), "");
		        }
		      }
		      System.out.println(spacer + "</" + name + ">");
		      break;
		    case Node.TEXT_NODE:
		      System.out.print("TEXT_NODE:"+node.getNodeValue());
		      break;
		    case Node.CDATA_SECTION_NODE:
		      System.out.print("CDATA_SECTION_NODE:"+"" + node.getNodeValue() + "");
		      break;
		    case Node.ENTITY_REFERENCE_NODE:
		      System.out.print("ENTITY_REFERENCE_NODE:"+"&" + node.getNodeName() + ";");
		      break;
		    case Node.ENTITY_NODE:
		      System.out.print("ENTITY_NODE:"+"<ENTITY: " + node.getNodeName() + "> </" + node.getNodeName() + "/>");
		      break;
		    case Node.DOCUMENT_NODE:
		    	System.out.println("DOCUMENT_NODE");
		      NodeList nodes = node.getChildNodes();
		      if (nodes != null) {
		        for (int i = 0; i < nodes.getLength(); i++) {
		          processNode(nodes.item(i), "");
		        }
		      }
		      break;
		    case Node.DOCUMENT_TYPE_NODE:
		      DocumentType docType = (DocumentType) node;
		      System.out.print("DOCUMENT_TYPE_NODE:"+"<!DOCTYPE " + docType.getName());
		      if (docType.getPublicId() != null) {
		        System.out.print(" PUBLIC " + docType.getPublicId() + " ");
		      } else {
		        System.out.print(" SYSTEM ");
		      }
		      System.out.println(" " + docType.getSystemId() + ">");
		      break;
		    default:
		      break;
		    }
		  }
	 public void processDocument(Node node){
		 
		 if(node == null){
			 return;
		 }
		 
		 switch (node.getNodeType()) {
		    
		    case Node.ELEMENT_NODE:
		      String name = node.getNodeName();
		      //System.out.print("ELEMENT_NODE:" + "<" + name);
		      if(name.equals(tagEnum.Title.toString())){
		    	  tagName = tagEnum.Title.toString();
		      }
		      NamedNodeMap nnm = node.getAttributes();
		      for (int i = 0; i < nnm.getLength(); i++) {
		        Node current = nnm.item(i);
		        //System.out.print(" " + current.getNodeName() + "= " + current.getNodeValue());
		      }
		    //  System.out.print(">");
		      
		      NodeList nl = node.getChildNodes();
		      if (nl != null) {
		        for (int i = 0; i < nl.getLength(); i++) {
		        	processDocument(nl.item(i));
		        }
		      }
		     // System.out.println(  "</" + name + ">");
		      break;
		    case Node.TEXT_NODE:
		    	if(tagName.equals(tagEnum.Title.toString())){
		    		this.Title = node.getNodeValue();
		    		//CommonMethod.screenPrint("Title:"+this.Title);
		    	}else if(tagName.equals(tagEnum.Title.toString())){
		    		this.Abstract = new StringBuffer(node.getNodeValue());
		    		//CommonMethod.screenPrint("Abstract:"+this.Abstract.toString());
		    	}else if(tagName.equals(tagEnum.RelatedWork.toString())){
		    		this.RelatedWork = new StringBuffer(node.getNodeValue());
		    		//CommonMethod.screenPrint("RelatedWork:"+this.RelatedWork.toString());
		    	}else if(tagName.equals(tagEnum.Reference.toString())){
		    		this.Reference = new StringBuffer(node.getNodeValue());
		    		//CommonMethod.screenPrint("Reference:"+this.Reference.toString());
		    	}
		     // System.out.print("TEXT_NODE:"+node.getNodeValue());
		      break;
		    case Node.CDATA_SECTION_NODE:
		      //System.out.print("CDATA_SECTION_NODE:"+"" + node.getNodeValue() + "");
		      break;
		    case Node.ENTITY_REFERENCE_NODE:
		      //System.out.print("ENTITY_REFERENCE_NODE:"+"&" + node.getNodeName() + ";");
		      break;
		    case Node.ENTITY_NODE:
		      //System.out.print("ENTITY_NODE:"+"<ENTITY: " + node.getNodeName() + "> </" + node.getNodeName() + "/>");
		      break;
		    case Node.DOCUMENT_NODE:
		    	//System.out.println("DOCUMENT_NODE");
		      NodeList nodes = node.getChildNodes();
		      if (nodes != null) {
		        for (int i = 0; i < nodes.getLength(); i++) {
		        	processDocument(nodes.item(i));
		        }
		      }
		      break;
		    case Node.DOCUMENT_TYPE_NODE:
		      DocumentType docType = (DocumentType) node;
		      //System.out.print("DOCUMENT_TYPE_NODE:"+"<!DOCTYPE " + docType.getName());
		      if (docType.getPublicId() != null) {
		        System.out.print(" PUBLIC " + docType.getPublicId() + " ");
		      } else {
		        System.out.print(" SYSTEM ");
		      }
		     // System.out.println(" " + docType.getSystemId() + ">");
		      break;
		    default:
		      break;
		    }
	 }
	 public String getTitle(){
		 return this.Title;
	 } 
	 public StringBuffer getAbstract(){
		 return this.Abstract;
	 } 
	 public StringBuffer getRelatedWork(){
		 return this.RelatedWork;
	 } 
	 public StringBuffer getReference(){
		 return this.getReference();
	 } 
		   public static void main0(){
		   String xmlFile = "D:\\work\\Gate\\trainingModel\\trainingTest.xml";
		   PaperXmlParser basicDOM = new PaperXmlParser (xmlFile);
		   basicDOM.parseDocument0();
	   }
	   public static void main1(){
		   String xmlFile = "D:\\work\\Gate\\trainingModel\\trainingTest.xml";
		   //String uri = "test.xml";
		    try {
		    	PaperXmlParser bd = new PaperXmlParser(xmlFile);
		    	
		    	System.out.println("Parsing XML File: " + xmlFile + "\n\n");
			      DOMParser parser = new DOMParser();
			      //parser.setFeature("http://xml.org/sax/features/validation", true);
			      //parser.setFeature("http://xml.org/sax/features/namespaces", false);
			      parser.parse(xmlFile);
			      Document doc = parser.getDocument();
			     bd.processNode(doc, "");
		      
		    } catch (Exception e) {
		      e.printStackTrace();
		      System.out.println("Error: " + e.getMessage());
		    }
	   }
	   	 public static void main2(){
		   String xmlFile = "D:\\work\\Gate\\trainingModel\\trainingTest.xml";
		   try {
		    	PaperXmlParser bd = new PaperXmlParser(xmlFile);
		    	bd.processDocument(bd.dom);
		    	CommonMethod.screenPrint(bd.toString());
		   } catch (Exception e) {
			      e.printStackTrace();
			      System.out.println("Error: " + e.getMessage());
		  }
	   }
	   	 public String toString(){
		 String rtn = "";
		 rtn+= "Title:"+this.getTitle()+"\n";
		 rtn+= "Abstract:"+this.getAbstract().toString()+"\n";
		 rtn+= "RelatedWork:"+this.getRelatedWork().toString()+"\n";
		 rtn+= "Reference:"+this.getReference().toString()+"\n";
		 return rtn;
	 }
	   
	      */
	   
	   
}
